#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>

#define WORD     unsigned int
#define DWORD   unsigned long int
#define BYTE     unsigned char
#define FALSE   0
#define TRUE     1

WORD TimerOff(void);
void InitTimerFunctions(void);
void TimerOn(void);
WORD func1(signed char far *buf1, int far *buf2);
WORD func2(signed char far *buf1, int far *buf2);
WORD func3(signed char far *buf1, int far *buf2);


WORD timer_hold,timer_diff;

/**************************************************************************
  void main(void)

  DESCRIPTION:

**************************************************************************/
void main(void)
{
  int i,j,k;
  BYTE far *soundbuffer;
  int far *mixbuffer;
  DWORD total;
  WORD t;
                                           // Allocate some buffer memory
  soundbuffer = (signed char far *)farmalloc(11000);
  if(!soundbuffer) exit(0);

  mixbuffer = (int far *)farmalloc(22000);
  if(!mixbuffer) {
    farfree(soundbuffer);
    exit(0);
  }


  for(i = 0; i < 10000; i++) {             // Initialize buffer contents
    *(soundbuffer+i) = 1;
    *(mixbuffer+i) = 2;
  }

  InitTimerFunctions();                    // Get timer functions ready


  clrscr();

  printf("Ready to test fnctions.  Press any key...\n");
  getch();
  func1(soundbuffer,mixbuffer);            // Flush out any interrupts
                                           // that might scew the time
                                           // results.


                                           //*****************************
                                           //
                                           // This next part of the code
                                           // puts the mixing  functions
                                           // through their paces.  After
                                           // each call, a time value is
                                           // printed along with buffer
                                           // data to make sure that
                                           // everything is behaving
                                           // normally.
                                           //
                                           //******************************

                                           // Test Function 1
  printf("\nTesting func 1 \n");
  total = 0;

  for(i = 0; i < 5; i++) {
    t = func1(soundbuffer,mixbuffer);
    total += t;
    printf("t= %u [ ",t);
    for(j = 0; j < 5; j++) printf("%d ",*(soundbuffer+j));
    printf("]  [");
    for(j = 0; j < 5; j++) printf("%d ",*(mixbuffer+j));
    printf("]\n");
  }
  printf("Average: %lu\n",total/5);

                                           // Test Function 2
  printf("\nTesting func 2 \n");
  total = 0;

  for(i = 0; i < 5; i++) {
    t = func2(soundbuffer,mixbuffer);
    total += t;
    printf("t= %u [ ",t);
    for(j = 0; j < 5; j++) printf("%d ",*(soundbuffer+j));
    printf("]  [");
    for(j = 0; j < 5; j++) printf("%d ",*(mixbuffer+j));
    printf("]\n");
  }
  printf("Average: %lu\n",total/5);

                                           // Test Function 3
  printf("\nTesting func 3 \n");
  total = 0;

  for(i = 0; i < 5; i++) {
    for(j = 0; j < 5; j++) *(mixbuffer+j) = -10;
    t = func3(soundbuffer,mixbuffer);
    total += t;
    printf("t= %u [ ",t);
    for(j = 0; j < 5; j++) printf("%d ",*(soundbuffer+j));
    printf("]  [");
    for(j = 0; j < 5; j++) printf("%d ",*(mixbuffer+j));
    printf("]\n");
  }
  printf("Average: %lu\n",total/5);

  getch();



  farfree(soundbuffer);                        // deallocate our buffers
  farfree(mixbuffer);
}


/**************************************************************************
  WORD func1()

  DESCRIPTION:  plain mixing routine.  This simply adds an array of
                signed characters into an array of intergers.

**************************************************************************/
WORD func1(signed char far *buf1, int far *buf2)
{
  int j;

  TimerOn();

  for(j = 0; j < 10000; j++) *(buf2+j) += *(buf1++);

  return(TimerOff());
}


/**************************************************************************
  WORD func2()

  DESCRIPTION:  fancy mixing function (Very critical.  This is where we
                should get our greatest speed increase.)  This does the
                same thing as the previous function, but this time I use
                fixed point arithmatic to allow for variable speed playback
                and there is some extra overhead to have volume changes
                as well.

**************************************************************************/
WORD func2(signed char far *buf1, int far *buf2)
{
  int pinc=255;
  WORD j,length=20000,*pos;
  DWORD position=0;
  BYTE volume = 64;

  pos = (WORD *)(((BYTE *)(&position))+1);

  TimerOn();

  for(j = 0; j < 10000; j++) {
    *(buf2+j) += (*(buf1 + *pos) * volume)>>4;
    position += pinc;
    if(*pos >= length) {
              // The code that normally goes here is not important, but the
              // if statement still needs to be included.
    }
  }

  return(TimerOff());

}
/**************************************************************************
  WORD func3(signed char far *buf1, int far *buf2)

  DESCRIPTION:  Buffer clipping code

**************************************************************************/
WORD func3(signed char far *buf1, int far *buf2)
{
  int far *mbuf;
  signed char far *dbuf;

  TimerOn();

  for(mbuf = buf2, dbuf = buf1; mbuf != buf2+10000; mbuf++) {
    if(*mbuf > 254) *mbuf = 254;       // Clip overload values
    else if(*mbuf < 1) *mbuf = 1;
    *(dbuf++) = *mbuf;
  }

  return(TimerOff());

}

/**************************************************************************
  void InitTimerFunctions()

  DESCRIPTION: Initializes speaker timer for timing operations.

**************************************************************************/
void InitTimerFunctions(void)
{
  BYTE b;

  b = inportb(0x61) & 0xfd;          // Read current port value.

                                     // Disable speaker output, but keep
                                     // timer 2 enabled.
  outportb(0x61,b | 0x01);
}


/**************************************************************************
  void TimerOn()

  DESCRIPTION: Turns on timer counter for a time measurement

**************************************************************************/
void TimerOn(void)
{
  outportb(0x43,0xb0);                // Set up the timer for countdown
  outportb(0x42,0xff);                // Least significant byte
  outportb(0x42,0xff);                // Most significant byte
}


/**************************************************************************
  WORD TimerOff()

  DESCRIPTION: Turns off time and reports clicks elapsed.  Note that this
               timer is so quick that it is wraps after only 56
               milliseconds.  If you want to timer longer stuff, I suggest
               using the global variable vclock.  It's tick frequency is
               sample_rate / dma_bufferlen.

               To convert to micro seconds, multiply the return value by
               0.838.

  RETURNS:
    Current timer count

**************************************************************************/
WORD TimerOff(void)
{
  outportb(0x43,0xc0);                 // Read the timer countdown status
  timer_hold = inportb(0x42) + inportb(0x42) * 256;

  timer_diff = 0xffff - timer_hold;   // timer_diff is used later
  return timer_diff;
}

