#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "sound.h"

char	  inst[9][11] =
	{
		{ 0x03,0x01,0x00,0x00,0xF3,0xE4,0x64,0x35,0x00,0x01,0x00},  // Harpsichord
		{ 0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x06,0x03,0x00},  // intro voice
    { 0x02,0x06,0x94,0x0A,0x80,0x80,0x00,0x00,0x00,0x00,0x00},  // intro voice
    { 0x00,0x04,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00},
    { 0x01,0x01,0x40,0x40,0x80,0x80,0x00,0x00,0x01,0x00,0x00},
    { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x01},
		{ 0xA5,0xB1,0xD2,0x80,0x81,0xF1,0x03,0x05,0x00,0x00,0x02},
		{ 0x72,0x62,0x1C,0x05,0x51,0x52,0x03,0x13,0x00,0x00,0x0E},
		{ 0x11,0x01,0x8A,0x40,0xF1,0xF1,0x11,0xB3,0x00,0x00,0x06}};


/**************************************************************************
	void main(void)

  DESCRIPTION: Example function that loads and "plays" a  midi file

**************************************************************************/
void main(void)
{
	int i,err;
  char errstring[256],r=0,string[255];
  static MIDI *bach  = NULL;



  music_volume = 63;

  clrscr();                           // clear screen

                                      // Grab a MIDI Port address
/*  printf("Enter MIDI port address in HEX notation [330]:");
  gets(string);
  if(strlen(string) == 0) midi_port = 0x330;   // default is 330
  else sscanf(string,"%X ",&midi_port);
*/
	midi_port = 0x320;
  clrscr();                           // Clear the screen again

  if(!SB_Setup()) {                   // Set up Sound Blaster
  	printf("SB_Setup returned this error: %s \n",errname[sberr]);
  	printf("(Is your 'BLASTER' environmen variable set up correctly?)\n");
    exit(0);
  }

  //Go_Varmint();                       // Start Varmint Kernel
  FM_Reset();                         // Reset FM Chip
	MPU_Reset();                        // Reset MPU-401 chip

  for(i = 0 ; i < 9; i++) {           // Reset Voices
		FM_SetVol(i,0);
		FM_SetVoice ( i,inst[0]) ; 				// initialize voice
  }
                                      // Load midi music file
  err = ReadMidi("cannon_d.mid",&bach,(char *)errstring);
  if(err) {
  	printf("MIDI read ERROR: %s\n",errstring);
    printf("Exit?\n");
    r = getch();
    if(r != 'n') return;
  }


  //printf("FORMAT:  %d  TRACKS: %d   DIVISION: %d\n",
	//				bach->format,bach->num_tracks,bach->divisions);

  midi_data = bach;                   // Set up Midi parameters
  midi_reset = TRUE;
                                      // Draw the main menu
  textcolor(MAGENTA);
  gotoxy(30,2);
  cprintf("MIDI demo menu (Port address: %X)",midi_port);
  textcolor(CYAN);
  gotoxy(30,4);
  cprintf("V,v - Change music volume");
  gotoxy(30,5);
  cprintf("T,t - Change music tempo");
  gotoxy(30,6);
  cprintf("B   - Begin music");
  gotoxy(30,7);
  cprintf("S   - Stop Music");
  gotoxy(30,8);
  cprintf("R   - Reset Music");
  gotoxy(30,9);
  cprintf("O   - Toggle output: FM");
  gotoxy(30,10);
  cprintf("Q   - Quit");


  while(toupper(r) != 'Q') {                  // MAIN LOOP
    gotoxy(30,14);                            // print temppo and volume stats
    textcolor(WHITE);
    cprintf("Music Volume: %d  ",music_volume);
    gotoxy(30,15);
    cprintf("Music Tempo:  %.2f  ",midi_usertempo);

    while(!kbhit()) {                         // handle the keyboard
    	//gotoxy(1,4);                            // check midi status while we wait
      //if(mpu_timeout < 1000) printf("MPU status: OK!         ");
      //else printf("MPU status: Timing out  ");
      MidiPlayer();
      msdelay(6);
    }
  	r = getch();                              // get keystroke

    if(r == 'V') {                            // Handle keystrokes
			music_volume++;
      if(music_volume > 0x3f) music_volume = 0x3f;
    }
    else if(r == 'v') {
      if(music_volume > 0) music_volume--;
    }
    else if(r == 'T') {
    	midi_usertempo *= 1.02;
      if(midi_usertempo > 10.0) midi_usertempo = 10.0;
    }
    else if(r == 't') {
    	midi_usertempo *= 0.98;
      if(midi_usertempo < 0.1) midi_usertempo = 0.1;
    }
    else if(toupper(r) == 'B') {
    	midi_on = TRUE;
		}
    else if(toupper(r) == 'S') {
    	midi_on = FALSE;
		}
    else if(toupper(r) == 'R') {
    	midi_reset = TRUE;
		}
    else if(toupper(r) == 'O') {
    	midi_out ^= TRUE;
      textcolor(CYAN);
      if(midi_out) {
  			gotoxy(30,9);
  			cprintf("O   - Toggle output: FM + MPU_401");
      }
      else {
   			gotoxy(30,9);
  			cprintf("O   - Toggle output: FM          ");
      }
		}
  }

  //Dropdead_Varmint();                // Close shop and go home
  MPU_Write(0xff);                   // Put things back how we found them
}
