#include "mod.h"
#include <conio.h>

#define DOWN_SEMITONE 		1.059463
#define UP_SEMITONE   		0.943874
#define DOSYNC	if(inportb(0x3da)&0x08) vsynccheck = 1

void dotick(void);
void dodiv(void);



MOD *mod_data = NULL;
int mod_on = FALSE,mod_reset = FALSE,mod_tablepos=0;
BYTE far *mod_pattern,*mod_pstop,*mod_loopspot=NULL;
int mod_loopcount = -1;
int mod_bytespertick = 220,mod_ticksperdivision = 6;
int mod_currentbyte = 0,mod_currenttick = 0;
int mod_divoffset =0;
int mod_glissando = FALSE;
int mod_finetune = 0;
int mod_patterndelay = 0;
int mod_volume = 9;
int mod_volumebyte = 7;
BYTE channel_select[4] = {1,1,1,1};
int vsynccheck = FALSE;

CHANNEL chan[4];



/**************************************************************************
	void dotick(void)

  DESCRIPTION:  Handles ongoing MOD commands at each tick.

**************************************************************************/
void dotick(void)
{
	int i,j,k;                        			// Local variable we need
  int samp;
  WORD period,rate;
	BYTE e1,e2,e3;
  float vibspot;

  for(i = 0; i < 4; i++) {                // Loop through all four channels
    e1 = chan[i].effect;                  // Get info aboput what is going on
		e2 = chan[i].x;
		e3 = chan[i].y;

    if(chan[i].retrigger) {               // Check for a retrigger signal
                                          // Time to retrigger?
    	if(!(mod_currenttick % chan[i].retrigger)) {
        chan[i].position = 0;
        chan[i].counter = 0;
        chan[i].end = mod_data->slength[chan[i].sample_number-1];
      }
    }

    if(chan[i].cut > -1) {                // Check for a cut signal
    	if(mod_currenttick >= chan[i].cut) chan[i].volume = 0;
    }

    switch(e1) {
    	case 0:                            	// Arpeggio
        chan[i].count++;
        switch(chan[i].count % 3) {
        	case 0:
          	chan[i].pinc = chan[i].data1;
            break;
        	case 1:
          	chan[i].pinc = chan[i].data2;
            break;
        	case 2:
          	chan[i].pinc = chan[i].data3;
            break;
        }
        break;
    	case 1:                            	// Slide up
                                             // glissando = chromatic slide
      	if(!mod_glissando) chan[i].period -= chan[i].porta;
        else for(k =0; k < chan[i].porta; k++) chan[i].period *= UP_SEMITONE;
                                             // Don't go too high
        if(chan[i].period < 1) chan[i].period = 1;
                                             // Set frequency counters
        rate = 7093789.2/(2*chan[i].period);
        chan[i].pinc = (rate * 256.0)/sample_rate;
        break;
    	case 2:                            	// slide down
      	if(!mod_glissando) chan[i].period += chan[i].porta;
                                             // glissando = chromatic slide
        else for(k =0; k < chan[i].porta; k++) chan[i].period *= DOWN_SEMITONE;
                                             // Don't go too low
        if(chan[i].period > 2000) chan[i].period = 2000;
                                             // Set frequency counters
        rate = 7093789.2/(2*chan[i].period);
        chan[i].pinc = (rate * 256.0)/sample_rate;
        break;
    	case 3:                            	// slide to note
                                             // Slide up or down? Each case is
                                             // just like regular up and down
                                             // slides.
      	if(chan[i].period < chan[i].period2) {
      		if(!mod_glissando) chan[i].period += chan[i].porta;
        	else for(k =0; k < chan[i].porta; k++) chan[i].period *= DOWN_SEMITONE;
          if((i == 1 || i == 2) && mod_tablepos == 3)debugnum++;
        	if(chan[i].period > chan[i].period2) chan[i].period = chan[i].period2;
        }
      	else if(chan[i].period > chan[i].period2) {
      		if(!mod_glissando) chan[i].period -= chan[i].porta;
        	else for(k =0; k < chan[i].porta; k++) chan[i].period *= UP_SEMITONE;
        	if(chan[i].period < chan[i].period2) chan[i].period = chan[i].period2;
        }
                                             // Set frequency counters
        rate = 7093789.2/(2*chan[i].period);
        chan[i].pinc = (rate * 256.0)/sample_rate;
        break;
    	case 4:                            	// vibrato
                                             // Calculate current waveform
      	vibspot = chan[i].vibperiod/32.0 *
									(double)mod_currenttick/mod_ticksperdivision * M_PI;
                                             // Adjust the period
      	period = chan[i].period + chan[i].vibdepth * vibspot;
                                             // Set frequency counters
        rate = 7093789.2/(2* period);
        chan[i].pinc = (rate * 256.0)/sample_rate;

        break;
    	case 5:                           	// Cont. Slide to note + vol. Slide
      	if(chan[i].period < chan[i].period2) {
      		chan[i].period += chan[i].porta;
          if((i == 1 || i == 2) && mod_tablepos == 3)debugnum++;
        	if(chan[i].period > chan[i].period2) chan[i].period = chan[i].period2;
        }
      	else if(chan[i].period > chan[i].period2) {
      		chan[i].period -= chan[i].porta;
        	if(chan[i].period < chan[i].period2) chan[i].period = chan[i].period2;
        }
        rate = 7093789.2/(2*chan[i].period);
        chan[i].pinc = (rate * 256.0)/sample_rate;

      	chan[i].volume += chan[i].vslide;
        if(chan[i].volume < 0) chan[i].volume = 0;
        if(chan[i].volume > 64) chan[i].volume = 64;
        break;
    	case 6:                            	// Vibrato + volume slide
      	vibspot = chan[i].vibperiod/32.0 *
									(double)mod_currenttick/mod_ticksperdivision * M_PI;
      	period = chan[i].period + chan[i].vibdepth * vibspot;
        rate = 7093789.2/(2* period);
        chan[i].pinc = (rate * 256.0)/sample_rate;

      	chan[i].volume += chan[i].vslide;
        if(chan[i].volume < 0) chan[i].volume = 0;
        if(chan[i].volume > 64) chan[i].volume = 64;
        break;
    	case 7:                            	// Tremolo
      																			 // Just like Vibrato except with
																						 // this modulates sample volume
     	vibspot = chan[i].vibperiod/32.0 *
									(double)mod_currenttick/mod_ticksperdivision * M_PI;
      	chan[i].volume = chan[i].volume2 + chan[i].vibdepth * vibspot;
        if(chan[i].volume < 0) chan[i].volume = 0;
        if(chan[i].volume > 64) chan[i].volume = 64;
        break;
    	case 10:                      			// Volume slide
      	chan[i].volume += chan[i].vslide;    // change the volume.
                                             // Clip.
        if(chan[i].volume < 0) chan[i].volume = 0;
        if(chan[i].volume > 64) chan[i].volume = 64;
        break;
    	case 14:
        switch(e2) {
        	case 13: 												//  Delay sample
                                             // data4 is decremented on each
                                             // Pass.  When it gets to zero,
                                             // the sample volume is turned
																						 // on.
          	if(!chan[i].data4) chan[i].volume = chan[i].data3;
            chan[i].data4--;
            break;
          default:
          	break;
        }
        break;
    	case 15:
        break;
      default:
      	break;
    }

    chan[i].volume *= channel_select[i];  // THis allows the user to mask
                                          // channels.
  }
}
/**************************************************************************
	void dodiv(void)

  DESCRIPTION:  Handles the commands found at a module division.

**************************************************************************/
void dodiv(void)
{
	int i,j,k;                              // Local variables we'll need
  int samp,pattern_break = FALSE,position_jump = FALSE,loop = FALSE;
  WORD period,rate;
	BYTE e1,e2,e3;
  float num;

  for(i = 0; i < 4; i++) {                // Loop through all four channels
  	chan[i].retrigger = 0;                // Reset retrigger and cut signals
  	chan[i].cut  = -1;
                                          // Grab information for this channel
  	samp = (*(mod_pattern)&0xF0) + ((*(mod_pattern+2) & 0xf0)>>4);
    period = (*(mod_pattern)&0x0F)*256 + *(mod_pattern+1);
    e1 = (*(mod_pattern+2)) & 0x0F;       // e1-e3 are the command nibbles
		e2 = (*(mod_pattern+3)  & 0xF0) >> 4;
		e3 = (*(mod_pattern+3)) & 0x0F;

    if(samp && e1 != 3) {                 // set a new sample?

      chan[i].sample_number = samp;       // Some MOD commmands need this
      chan[i].sdata = mod_data->sdata[samp-1]; // set a pointer to the data
      chan[i].position = 0;               // Retrigger the sample
      chan[i].counter = 0;
                                          // store sample characteristics
      chan[i].offset = mod_data->offset[samp-1];
      chan[i].rlength = mod_data->repeat[samp-1];
                                          // Keep track of end so we know
                                          // When to stop.
      chan[i].end = mod_data->slength[samp-1];
                                          // Set the volume to the default
      chan[i].volume = mod_data->volume[samp-1];

    }

    if(period && e1 != 3) {               // Set a new period?
                                          // Calculate adjusted period
    	chan[i].period = period + mod_data->finetune[chan[i].sample_number-1]
			                        + mod_finetune;
                                          // Set frequency counter
      rate = 7093789.2/(2*period);
      chan[i].pinc = (rate*256.0)/sample_rate;
    }


    chan[i].effect = e1;                 	// Keep for reference in dotick()
    chan[i].x = e2;
    chan[i].y = e3;

    switch(e1) {                          // Process the commands
    	case 0:															// Arpeggio
      	chan[i].data1 = chan[i].pinc;     	 // First frequncy

      	num = chan[i].pinc;              	   // calculate second frequency
        for(j = 0; j < e2; j++) num *= UP_SEMITONE;
        chan[i].data2  = (DWORD)num;

      	num = chan[i].pinc;              	   // calculate third frequncy
        for(j = 0; j < e3; j++) num *= UP_SEMITONE;
        chan[i].data3  = (DWORD)num;
        chan[i].count = 0;
        break;
    	case 1:                            	// Slide up.
      	chan[i].porta = e2*16 + e3;          // Calculate slide rate
        break;
    	case 2:                            	// slide down
      	chan[i].porta = e2*16 + e3;          // calculate slide rate
        break;
    	case 3:                            	// Slide to note
      	if(e2 || e3) chan[i].porta = e2*16 + e3;
        if(period) chan[i].period2 = period;
        break;
    	case 4:                            	// Vibrato (My implementation
                                         	// Of this command assumes that
																				 	// The wave form is a triggered
																				 	// Sin wave.   There are other
																				 	// forms defined , but they are
																				 	// use very rarely and I dont't
																				 	// feel like coding them in.

                                             // These numbers will be used
                                             // to calculate the waveform.
      	if(e2) chan[i].vibperiod = e2* mod_ticksperdivision;
				if(e3) chan[i].vibdepth = ((e3/16.0) * 0.0595 ) * chan[i].period;
        break;
    	case 5:                            	// Continue Slide to Note + Volume Slide
    	case 6:                            	// Continue Vibrato + volume slide
                                             // For both of these commands,
                                             // We just need to keep track
                                             // of the volume slide rate
        if((e2 > 0 && e3 > 0) || e3 == 0) chan[i].vslide = e2;
        else chan[i].vslide = -e3;
                                             // If the period is specified,
                                             // Then the volume needs to be
                                             // reset.
        if(period)chan[i].volume = mod_data->volume[chan[i].sample_number-1];
        break;
    	case 7:                            	// Tremolo (My implementation
                                         	// Of this command assumes that
																				 	// The wave form is a triggered
																				 	// Sin wave.   There are other
																				 	// forms defined , but they are
																				 	// use very rarely and I dont't
																				 	// feel like coding them in.

                                             // These values will be used to
                                             // claculate the wave form
      	if(e2) chan[i].vibperiod = e2* mod_ticksperdivision;
				if(e3) chan[i].vibdepth = e3;
        chan[i].volume2 = chan[i].volume;
        break;
    	case 8:                            	// UNUSED
        break;
    	case 9:                            	// Set new sample offset
      	mod_data->offset[chan[i].sample_number-1] = (e2*4096+e3*256)*2;
        break;
    	case 10:                           	// Volume slide
                                             // Calculate slide rate
        if((e2 > 0 && e3 > 0) || e3 == 0) chan[i].vslide = e2;
        else chan[i].vslide = -e3;
        if(period)chan[i].volume = mod_data->volume[chan[i].sample_number-1];
        break;
    	case 11:                           	// Table position jump
      	mod_tablepos = e2*16+e3;
        position_jump = TRUE;
        break;
    	case 12:                           	// Set Volume
        chan[i].volume = e2*16+e3;
        break;
    	case 13:                           	// Pattern Break
      	pattern_break = TRUE;                // We'll do the break later.
        break;
    	case 14:
        switch(e2) {
        	case 0:                        	// Set filter.  I just ignore this
                                          // since it is a hardware option
            break;
        	case 1:                        	// Fineslide up
                                             // Recalculate frequency counter
          	chan[i].period -= e3;
            rate = 7093789.2/(2* chan[i].period);
            chan[i].pinc = (rate*256.0)/sample_rate;
            break;
        	case 2:                        	// Fineslide down
                                             // Recalculate frequncy counter
          	chan[i].period += e3;
            rate = 7093789.2/(2* chan[i].period);
            chan[i].pinc = (rate*256.0)/sample_rate;
            break;
        	case 3:                        	// Glissando on/off
                                         	// If this is on, slide-to-note
                                         	// functions should slide by
                                         	// semitones rather than smooth
                                         	// slides.  This is rarely used.
          	mod_glissando = e3;
            break;
        	case 4:                        	// Vibrato waveform. This is rarely
                                         	// used, so for now, the code is
                                         	// locked in to use the default
																				 	// waveform: 0  (a triggered sin
                                         	// wave)
            break;
        	case 5:                        	// Set sample finetune value
          	k = e3;
            if (k > 7) k -= 16;
            mod_data->finetune[chan[i].sample_number-1] =  k;
            break;
        	case 6:                         // Loop Pattern
          		                               // mod_loopcount is a global
                                             // used to keep track of the loop.
          	if(mod_loopcount == -1) {
	          	if(!e3) mod_loopspot = mod_pattern;
	            else {
	            	if(!mod_loopspot) mod_loopspot =
	          			mod_data->pattern_data[mod_data->ptable[mod_tablepos]];
	              mod_loopcount = e3;
                loop = TRUE;
	            }
            }
            else if(e3){
            	if(!mod_loopcount) mod_loopspot = NULL;
              else loop = TRUE;
              mod_loopcount--;
            }
            break;
        	case 7:                        	// Termolo waveform.  (see case #4)
            break;
        	case 8:                        	// UNUSED
            break;
        	case 9:                         // Retrigger sample
          	chan[i].retrigger = e3;          // Set the retrigger signal used
                                             // in dotick().
            break;
        	case 10:                        // Fineslide volume up
          	chan[i].volume += e3;
            if(chan[i].volume > 64) chan[i].volume = 64;
            break;
        	case 11:                        // Fineslide volume down
          	chan[i].volume -= e3;
            if(chan[i].volume < 0) chan[i].volume = 0;
            break;
        	case 12:                        // Cut Sample
            chan[i].cut = e3;                // Set cut signal for dotick()
            break;
        	case 13:                      	// Delay sample
          	chan[i].data4 = e3;              // Set counter for dotick()
            chan[i].data3 = chan[i].volume;
            chan[i].volume = 0;              // Turn off volume
            break;
        	case 14:                        // Pattern Delay
          	mod_patterndelay = e3;
            break;
        	case 15:                        // Invert Loop.  THis is too much
                                          // of a headache to worry about
                                          // right now. Sorry.
            break;
          default:                        // Shouldn't ever get here
            break;
        }
        break;
    	case 15:                            // Set Speed.
      					                             // There are two possible actions
                                             // with this command:  change
                                             // ticks per beat, or change
                                             // beats per minute.  Right
                                             // now, only the ticks per beat
                                             // have been implemented.
      	j = e2*16+e3;
      	if(j <= 32) {
					if(!j) j = 1;
					mod_ticksperdivision = j;
        }
        break;
      default:                            // shouldn't happen.
        break;
    }
    mod_pattern += 4;                     // Advance to next channel
  }

  if(loop) {                              // Loop?  Jump back to placeholder!
  	mod_pattern = mod_loopspot;
  }
  else if(pattern_break) {                // Pat. break?  Jump to next pattern!
    mod_tablepos++;
    if(mod_tablepos == mod_data->num_positions) mod_on = FALSE;
    else {
			mod_pattern = mod_data->pattern_data[mod_data->ptable[mod_tablepos]];
      mod_pstop = mod_pattern+1024;
    }
  }
  else if(position_jump) {                // Position jump?  Go to specified
                                          // Table.
    if(mod_tablepos == mod_data->num_positions) mod_on = FALSE;
    else {
			mod_pattern = mod_data->pattern_data[mod_data->ptable[mod_tablepos]];
      mod_pstop = mod_pattern+1024;
    }
  }
}

/**************************************************************************
	static void far interrupt mod_int()

  DESCRIPTION:  This is the sound Blaster interrupt that is to be
  							called at the end of DMA transfer.  This is how the flow
                of things goes:

                 	Dump last mix to the DMA buffer
                  Mix regular samples
                  Mix MOD stuff
                  Calculate next DMA buffer
                  acknowledge interrupt
                  Run the midi stuff.

                This particular function is used to play MOD files

**************************************************************************/
void far interrupt mod_int(void)
{
  int d,i,j;
	WORD lastbyte;
  int far *mbuf;
  BYTE far *dbuf;
  static long int midi_count = 100;

  vsynccheck = 0;                  // Reset Vertical retrace variable

  if(DSP_overhead) timer_on();     // start timer to measure DSP overhead

                                   // Copy in playahead section of the buffer
	memcpy(dma_buffer,playahead_buffer,dma_bufferlen+1);

  DOSYNC;                          // Macro for checking the vertical retrace
                                   // clear out the mixing buffer
  for(j = 0; j < dma_bufferlen+1; j++) *(mix_buffer+j) = 128;
  DOSYNC;

                                   // Mix in digitized sounds
  for(i = 0; i <sounds_in_queue; i++) {
    DOSYNC;
  	if(soundpos[i]>=dma_bufferlen) {// enough left to fill the buffer?
    	for(j = 1; j < dma_bufferlen+1; j++) *(mix_buffer+j) += *(sounddata[i]++);
    	soundpos[i] -= (dma_bufferlen);
    }
    else {                         // else play what is left
    	for(j = 1; j <= soundpos[i]; j++) *(mix_buffer+j) += *(sounddata[i]++);
                                   // delete the sound
      for(j = i; j < sounds_in_queue;j++) {
        sounddata[j] = sounddata[j+1];
        soundpos[j] = soundpos[j+1];
      }
      sounds_in_queue--;           // One less sound.
      i--;                         // make sure we don't skip the next sound
    }
  }
  DOSYNC;

  if(mod_on && mod_data) {         // MOD stuff activated and ready?
    if(mod_reset) {                // Reset the MOD?
      for(i = 0; i < 4; i++ ) {    // Reset all four channels
	      chan[i].sdata = NULL;
        chan[i].offset = 0;
				chan[i].rlength = 0;
				chan[i].end = 0;
        chan[i].volume = 0;
        chan[i].sample_number = 0;
        chan[i].position= 0;
        chan[i].counter = 0;
				chan[i].pinc = 0;
        chan[i].effect = 0;
				chan[i].x = 0;
				chan[i].y = 0;
      }
    	                             // Reset global mod variables
      mod_pattern=mod_data->pattern_data[mod_data->ptable[0]];
      mod_pstop = mod_pattern+1024;
			mod_tablepos=0;
			mod_bytespertick = sample_rate/11000.0 * 220;
			mod_ticksperdivision = 6;
      mod_currentbyte = 0;
			mod_currenttick = 0;
      mod_divoffset =0;

      mod_reset = FALSE;           // Reset the reset switch
    }
                                   // **************************************
                                   // This little section mixes all the mod
                                   // channels if the number of bytes left
                                   // to go until the next tick is bigger
                                   // than the dma_buffer length.
                                   // **************************************
    if(mod_currentbyte > dma_bufferlen) {
    	for(i = 0; i < 4; i++) {     // Loop through the four channels
      	DOSYNC;

                                   // If the volume is zero or if the sample
                                   // has ended, then there is no need to mix
                                   // anything.
				if(chan[i].volume && chan[i].position <= chan[i].end) {
                                   // Loop along the length of the mixing buffer
          for(j = 0; j < dma_bufferlen+1; j++) {
                                   // Add this byte to the mixing buffer
        	  *(mix_buffer+j) += (*(chan[i].sdata + chan[i].position) * chan[i].volume)>>mod_volumebyte;
                                   // Here is where the frequency magic
                                   // happens.  I use fixed point arithmatic
                                   // to increment the sample position pointer
                                   // at different rates.
            chan[i].counter += chan[i].pinc;
            chan[i].position += chan[i].counter>>8;
            chan[i].counter &= 0x00ff;
                                   // Are we at the end of the sample?
            if(chan[i].position >= chan[i].end) {
                                   // Repeating?  Move the position back.
        	    if(chan[i].rlength > 1) {
        		    chan[i].position = chan[i].offset;
                chan[i].counter = 0;
                chan[i].end = chan[i].offset+chan[i].rlength;
              }

              else break;          // else Jump out of mixing loop
            }
          }
        }
      }
                                   // Keep track of where we are.
      mod_currentbyte -= dma_bufferlen+1;
    }
                                   // **************************************
                                   // This little section mixes all the mod
                                   // channels if the number of bytes left
                                   // to go until the next tick is *smalleer*
                                   // than the dma_buffer length.
                                   //
                                   // It first mixes what is left, then it
                                   // decrements the tick and calls out
                                   // to the module handling routines.
                                   // Once that is donde, it mixes the
                                   // rest of the DMA buffer.
                                   //
                                   // The two mixing routines are extacly the
                                   // same as the one above except the first
                                   // one loops over the first part of the
                                   // mixing buffer, and the second mixes
                                   // over the rest.
                                   // **************************************

    else {
                                   // Mix the first part of the buffer
    	for(i = 0; i < 4; i++) {
      	DOSYNC;
				if(chan[i].volume && chan[i].position <= chan[i].end) {
          for(j = 0; j < mod_currentbyte+1; j++) {
        	  *(mix_buffer+j) += (*(chan[i].sdata + chan[i].position) * chan[i].volume)>>mod_volumebyte;

            chan[i].counter += chan[i].pinc;
            chan[i].position += chan[i].counter>>8;
            chan[i].counter &= 0x00ff;

            if(chan[i].position >= chan[i].end) {
        	    if(chan[i].rlength > 1) {
        		    chan[i].position = chan[i].offset;
                chan[i].counter = 0;
                chan[i].end = chan[i].offset+chan[i].rlength;
              }
              else break;
            }
          }
        }
      }

      lastbyte = mod_currentbyte+1;  // Keep track of where we are inthe buffer

                                   // Ready for next division?
      if(mod_currenttick >= mod_ticksperdivision * (mod_patterndelay+1) ) {
        mod_patterndelay = 0;      // Reset pattern delay
        dodiv();                   // Handle the division commands.

                                   // Are we at the end of the pattern?
        if(mod_pattern == mod_pstop) {
          mod_tablepos++;          // Next table!

                                   // Done with tables?  Done with MOD.
          if(mod_tablepos == mod_data->num_positions) mod_on = FALSE;
          else {                   // Otherwise, set pointer to next table
					  mod_pattern = mod_data->pattern_data[mod_data->ptable[mod_tablepos]];
            mod_pstop = mod_pattern+1024;
          }
        }
        mod_currenttick = 0;       // Reset the tick counter
      }
                                   // Reset the byte counter
      mod_currentbyte = mod_bytespertick;

      mod_currenttick++;           // Do our tick stuff.
      dotick();
                                   // Mix the rest of the buffer
    	for(i = 0; i < 4; i++) {
      	DOSYNC;
				if(chan[i].volume && chan[i].position <= chan[i].end) {
          for(j = lastbyte; j < dma_bufferlen+1; j++) {
        	  *(mix_buffer+j) += (*(chan[i].sdata + chan[i].position) * chan[i].volume)>>mod_volumebyte;

            chan[i].counter += chan[i].pinc;
            chan[i].position += chan[i].counter>>8;
            chan[i].counter &= 0x00ff;

            if(chan[i].position >= chan[i].end) {
        	    if(chan[i].rlength > 1) {
        		    chan[i].position = chan[i].offset;
                chan[i].counter = 0;
                chan[i].end = chan[i].offset+chan[i].rlength;
              }
              else break;
            }
          }
        }
      }
                                   // Update our position
      mod_currentbyte -= (dma_bufferlen-lastbyte +1);
    }

    DOSYNC;
  }


                                   // Write mixed stuff to the playback buffer
  for(mbuf = mix_buffer, dbuf = playahead_buffer;
			mbuf != mix_buffer+dma_bufferlen+2;
			mbuf++) {
		if(*mbuf > 254) *mbuf = 254;       // Clip overload values
		else if(*mbuf < 1) *mbuf = 1;
    *(dbuf++) = *mbuf;
  }
  DOSYNC;

  *dma_buffer = *(dma_buffer+dma_bufferlen); // * BLACK MAGIC *  Setting this byte
                                       // prevents static that seems to
                                       // be caused when other interrupts
                                       // get interrupted by this one.

    																	 // Reset interrupt.
	asm mov al,0x20;
	asm out 0x20,al; // set EOI
	asm mov bx,intnr
	asm cmp bx,7
	asm jbe end
	asm out 0xa0,al; // set EOI
end:

                                     // acknowledge DSP interrupt
	asm mov dx,io_addr;
	asm add dx,DSP_RSTATUS;
	asm in al,dx;

  DOSYNC;


                                   // Varmint's system clock
  vclock ++;

																	 // MIDI stuff first
  midi_count-= 100;
  if(midi_count < 100) {
  	MidiPlayer();                  // Call a midi player
    midi_count += midi_callfreq * midi_usertempo*100.0; // reset counter
    DOSYNC;
  }

  if(DSP_overhead) DSP_overhead = timer_off();//  How long did this take?

}


/**************************************************************************
	void freemod(MOD *freeme)

  DESCRIPTION: Frees all the memory associated with a MOD file.

  BYTE far *pattern_data[128];
  SAMPLE *sdata[32];

**************************************************************************/
void freemod(MOD *freeme)
{
	int i;

  for(i = 0; i <32; i++) {         	// Free the samples
		if(freeme->sdata[i]) farfree(freeme->sdata[i]);
  }
  for(i = 0; i <128; i++) {         // Free the pattern data
		if(freeme->pattern_data[i]) farfree(freeme->pattern_data[i]);
  }
  free(freeme);

}
/**************************************************************************
	MOD *loadmod(char *modfilename)

  DESCRIPTION:  Loads a Module file (Noise,Sound, or Protracker)


**************************************************************************/
MOD *loadmod(char *modfilename)
{
	int i,j,k,ft;
  BYTE dummy;
  FILE *input;
  MOD *m;
  char signature[5];
  int samples = 15;

  m = (MOD *)malloc(sizeof(MOD));         // Allocate the skeleton MOD struct
  if(!m) {
  	return(NULL);
  }

  input = fopen(modfilename,"rb");   			// access the file
  if(!input) {
  	free(m);
    return(NULL);
	}

  fseek(input,1080, SEEK_SET);            // Look for signatures so we
                                          // can tell of this MOD has 15
                                          // Or 31 samples.
  fread(signature,1,4,input);
  signature[4] = 0;
  if(!strcmp(signature,"M.K.")) samples = 31;
  else if(!strcmp(signature,"M!K!")) samples = 31;
  else if(!strcmp(signature,"FLT4")) samples = 31;

  rewind(input);                          // Go back to the start.

  fread(m->title,1,20,input);        			// read the module title

  m->num_samples = 0;

  for(i = 0; i < samples; i++) {          // read the sample headers
  	fread(m->sample_name[i],1,22,input);  // name
                                          // length (convert words to bytes)
    m->slength[i] = (fgetc(input) * 256+ fgetc(input))*2;
    ft = fgetc(input)&0x0f;        				// finetune
    if(ft>7) ft -=16;                     // Convert to a signed value
    m->finetune[i] = ft;

    m->volume[i] = fgetc(input);          // Sample volume
                                          // repeat offset (words -> bytes)
    m->offset[i] = (fgetc(input) * 256 + fgetc(input))*2;
                                          // repeat length (words -> bytes)
    m->repeat[i] = (fgetc(input) * 256 + fgetc(input))*2;
    if(m->repeat[i] == 2) m->repeat[i] = 0;

                                          // Sometimes the repeat length
                                          // and offset are not set properly,
                                          // so we have to do a little
                                          // patching here.
    if(m->offset[i] + m->repeat[i] > m->slength[i] ) {
      if(m->repeat[i] > m->slength[i]) {
      	m->repeat[i] = m->slength[i];
        m->offset[i] = 0;
      }
      else {
      	m->offset[i] -= (m->repeat[i] + m->offset[i] - m->slength[i]);
      }
		}

    if(m->slength) m->num_samples++;      // Keep track of the number of real smaples
  }

  m->num_positions = fgetc(input);        // number of patterns to play
  dummy = fgetc(input);                   // unused byte
  fread(m->ptable,1,128,input);           // read pattern table

  if(samples == 31) {
  	fread(m->sig,1,4,input);              // read module signature
  	m->sig[4] = 0;
  }
  else strcpy(m->sig,"NONE");

  m->maxpattern = 0;

  for(i = 0; i < m->num_positions; i++) { // Find number of unique patterns
  	if(m->ptable[i] > m->maxpattern) m->maxpattern = m->ptable[i];
  }

  for(i=0;i<128;i++) m->pattern_data[i]=NULL;	// Reset pattern buffer pointers

  for(i = 0; i <= m->maxpattern; i++) {   // read in 1024-byte patterns
    m->pattern_data[i] = (BYTE far *)farmalloc(1024);

    if(!m->pattern_data[i]) {             // Did we get the memory?
                                          // If not, free what we have
                                          // and go home.
    	for(j = 0; j < i; j++) free(m->pattern_data[j]);
      free(m);
      return(NULL);
    }
    fread(m->pattern_data[i],1,1024,input);  // Read in the pattern
  }

  for(i = 0; i <samples; i++) {       		// Read in the sample data
  	m->sdata[i] = NULL;                   // Reset sample
    if(!m->slength[i]) continue;          // Continue if nothing to read

  	m->sdata[i] = (SAMPLE *)farmalloc(m->slength[i]+1);

    if(!m->sdata[i]) {                    // Did we get the memory?
                                          // If not, free what we have
                                          // and go home.
    	for(j = 0; j <= m->maxpattern; j++) free(m->pattern_data[j]);
    	for(j = 0; j < i; j++) free(m->sdata[j]);
      free(m);
      return(NULL);
    }
                                          // Read in the sample
  	fread(m->sdata[i],1,m->slength[i],input);

  }
  fclose(input);                          // All done!


  return(m);                              // Give the new Module back to
                                          // the caller.

}

