#include "mouse.h"

/**************************************************************************
	void mouseinit()

  DESCRIPTION: Initializes the mouse driver

  	int 33h commands (held by ax);

    	0	- Init mouse (if ax = 0, mouse is not installed)
      1 - show cursor
      2 - Hide Mouse cursor
      3 - get mouse position
      4 - Set cursor position (cx = x, dx = y)

      11 - Get motion
**************************************************************************/
int mouseenter()
{
	asm {
  	mov ax,0                     // initialize driver command
    int 0x33
  }
	return(_AX);                   // return the result

}


/**************************************************************************
	void mouseshow()

  DESCRIPTION:  shows the mouse cursor

**************************************************************************/
void mouseshow()
{
	asm mov ax,1;
  asm int 0x33;
}
/**************************************************************************
	void mousehide()

  DESCRIPTION:  Hides the mouse cursor

**************************************************************************/
void mousehide()
{
	asm mov ax,2;
  asm int 0x33;
}

/**************************************************************************
	void getmouse(int mouseinfo[6])

  DESCRIPTION:  Gets current mouse position

**************************************************************************/
void mousestatus(int *x, int *y, int *buttons)
{
	int mx,my,mb;

	asm {
  	mov ax,3
    int 0x33
    mov mx,cx
    mov my,dx
    mov mb,bx
  }

  *x = mx;
  *buttons = mb;
  *y = my;
}




