#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "windows.h"
#include "vwcolors.h"
#include "graphics.h"
#include "mouse.h"
#include "vat.h"

#define BYTE unsigned char
#define WORD unsigned int

#define WINDOW_IS(x) !strcmp(child,x)

typedef struct {
	char name[32];
  BYTE data[11];
} VOICEDEF;
        												// Function prototypes
void main_menu(void);
void setup_graphics(void);
void slidercb(WINDOW *sw);
void buildhex(char string[],VOICEDEF *v);


                                // Global Variables
int pal[16];
VOICEDEF voicelist[128];
int total_mv = 128;
char hexchar[16] = {"0123456789ABCDEF"};
char voice_filename[20] = {"voices.vcf"};
MIDI *midi1,*midi2,*midi3;
SAMPLE *doink = NULL;
DWORD doinklength = 0;

extern BYTE midi_volume;
extern int midi_on,midi_reset;

/**************************************************************************
	main(void)

  DESCRIPTION:  Main.  Here it is.

**************************************************************************/
main(void)
{
	int i,j,k,errorcode;
                                // Load Midi stuff
  printf("READING test1.mid...\n");
  midi1 = LoadMidi("test1.mid",errstring);
  if(!midi1) {
  	printf("MIDI read ERROR: %s\n",errstring);
		exit(1);
  }
  printf("READING test1.mid...\n");
  midi2 = LoadMidi("test2.mid",errstring);
  if(!midi2) {
  	printf("MIDI read ERROR: %s\n",errstring);
		exit(1);
  }
  printf("READING bach.mid...\n");
  midi3 = LoadMidi("bach.mid",errstring);
  if(!midi3) {
  	printf("MIDI read ERROR: %s\n",errstring);
		exit(1);
  }


  if(!SBSetUp()) {
  	printf("No SoundBlaster Hardware detected.\n");
    exit(0);
  }
                                // reset all voices
  for(i  = 0; i < total_mv; i++) {
  	sprintf(voicelist[i].name,"Voice %d",i);
    for (j = 0; j < 11; j++) voicelist[i].data[j] = 0;
  }
                                // Load windows file
  errorcode = readwindows("voiceed.wnf");
  if(errorcode) {
  	printf("An error has occured reading voiceed.wnf (%d)\n",errorcode);
  	exit(0);
	}

  printf("READING doinkwav...\n");
  doink = LoadWave("doink.wav",&doinklength);     // Load up our sound effects


  printf("Setting up graphics...\n");
  setup_graphics();
  printf("Running Varmint tools...\n");
  GoVarmint();
  main_menu();
	DropDeadVarmint();
  closegraph();

  return 0;
}


/**************************************************************************
	void setup_graphics(void)

  DESCRIPTION: Prepares a VGA graphics mode for FUN FUN FUN

**************************************************************************/
void setup_graphics(void)
{
  int i,gdriver = VGA, gmode = VGAHI, errorcode;
  int x,y,b;

  registerfarbgidriver(EGAVGA_driver_far);
  registerfarbgifont(small_font_far);

  initgraph(&gdriver, &gmode, "");  				/* start graphics */

	errorcode = graphresult();

	if (errorcode != grOk) { 									/* an error occurred */
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		exit(1);             									/* return with error code */
	}

	pal[0] = 0; pal[1] = 1; pal[2] = 2; pal[3] = 3; pal[4] = 4;
	pal[5] = 5; pal[6] = 20; pal[7] = 7;
	for (i = 8; i<16; i++) pal[i] = i + 48;

	for(i=1; i<8; i++) {               				/* spruce up the palette */
		setrgbpalette(pal[i],i*9,i*9,i*9);    	/* greyscale */
	}

	setrgbpalette(pal[8],20,20,63);           /* rainbow colors */
	setrgbpalette(pal[9],0,63,63);
	setrgbpalette(pal[10],0,32,0);
	setrgbpalette(pal[11],0,63,0);
	setrgbpalette(pal[12],63,63,0);
	setrgbpalette(pal[13],63,0,0);
	setrgbpalette(pal[14],63,0,63);
	setrgbpalette(pal[15],32,0,32);
                                            // set Up a tiny font

  settextstyle(SMALL_FONT,0,0);
																						/* initialize mouse and show it */
	if(!mouseenter()) {
		printf("Mouse Initializaion failed.");
		exit(1);
	}
	mouseshow();

  initwindows();

}

/**************************************************************************
	voice main_menu(void)

  DESCRIPTION: Handles the main menu.  Not much more than this/

**************************************************************************/
void main_menu(void)
{
	int w,x,y,i,j,k,cur_voice=0,copy_voice=0,note = 64,channel = 0;
  int quit,newvoice =1;
  int ampmod1,ampmod2,vib1,vib2,sus1,sus2,ksc1,ksc2,mfm1,mfm2,scl1,scl2;
  int atr1,atr2,dcr1,dcr2,stl1,stl2,rer1,rer2,fdb,modsel,wfs1,wfs2,voice;
  int key0,key1,key2,key3,key4,key5,key6,key7,key8,key9;
  int filename,load,save,voicename,volume,tempo,copy,paste;
  int midia,midib,midic,midireset,midistop,fmreset,playnote = 0;
  int special;
  VOICEDEF *v;
  char string[256];
  FILE *vfile;
  WINDOW *win;
  BYTE storage[11];

  FMReset();                             // Set up the FM voices
  for(i = 0; i < 9; i++) {
		FMKeyOff(i);
		FMSetVoice (i,voicelist[cur_voice].data) ;
    FMSetVolume(i,0);
  }
                                        // Draw the menu...
 	drawwindow("WORK SPACE");
  drawwindow("MAIN MENU LABEL");
  drawwindow("MM OPER1 LABEL");
  drawwindow("MM OPER2 LABEL");
  drawwindow("MM AMP MOD LABEL");
  drawwindow("MM VIB LABEL");
  drawwindow("MM SUS LABEL");
  drawwindow("MM KSC LABEL");
  drawwindow("MM MFM LABEL");
  drawwindow("MM SCL LABEL");
  drawwindow("MM ATR LABEL");
  drawwindow("MM DCR LABEL");
  drawwindow("MM STL LABEL");
  drawwindow("MM RER LABEL");
  drawwindow("MM FDB LABEL");
  drawwindow("MM MOD SELECT LABEL");
  drawwindow("MM WFS LABEL");
  drawwindow("MM VOLUME LABEL");
  drawwindow("MM TEMPO LABEL");

  drawwindow("MM NAME LABEL");

  drawwindow("MM KEY0");
  drawwindow("MM KEY1");
  drawwindow("MM KEY2");
  drawwindow("MM KEY3");
  drawwindow("MM KEY4");
  drawwindow("MM KEY5");
  drawwindow("MM KEY6");
  drawwindow("MM KEY7");
  drawwindow("MM KEY8");
  drawwindow("MM KEY9");
  drawwindow("MM QUIT");
  drawwindow("MM FILENAME LABEL");
  drawwindow("MM FILENAME");
  drawwindow("MM SAVEFILE");
  drawwindow("MM LOADFILE");
  drawwindow("MM MIDI A");
  drawwindow("MM MIDI B");
  drawwindow("MM MIDI C");
  drawwindow("MM MIDI STOP");
  drawwindow("MM MIDI RESET");
  drawwindow("MM FM RESET");
  drawwindow("MM COPY");
  drawwindow("MM PASTE");
                                         // Get all the window ids...

  special = getwindowid("MAIN MENU LABEL");
  quit = getwindowid("MM QUIT");
  ampmod1 = getwindowid("MM AMP MOD 1");
  ampmod2 = getwindowid("MM AMP MOD 2");
  vib1 = getwindowid("MM VIB 1");
  vib2 = getwindowid("MM VIB 2");
  sus1 = getwindowid("MM SUS 1");
  sus2 = getwindowid("MM SUS 2");
  ksc1 = getwindowid("MM KSC 1");
  ksc2 = getwindowid("MM KSC 2");
  mfm1 = getwindowid("MM MFM SLIDER 1");
  mfm2 = getwindowid("MM MFM SLIDER 2");
  scl1 = getwindowid("MM SCL SLIDER 1");
  scl2 = getwindowid("MM SCL SLIDER 2");
  atr1 = getwindowid("MM ATR SLIDER 1");
  atr2 = getwindowid("MM ATR SLIDER 2");
  dcr1 = getwindowid("MM DCR SLIDER 1");
  dcr2 = getwindowid("MM DCR SLIDER 2");
  stl1 = getwindowid("MM STL SLIDER 1");
  stl2 = getwindowid("MM STL SLIDER 2");
  rer1 = getwindowid("MM RER SLIDER 1");
  rer2 = getwindowid("MM RER SLIDER 2");
  fdb  = getwindowid("MM FDB SLIDER");
  modsel = getwindowid("MM MOD SELECT");
  wfs1 = 	getwindowid("MM WFS SLIDER 1");
  wfs2 = getwindowid("MM WFS SLIDER 2");
  voice = getwindowid("MM NAME SLIDER");
  volume = getwindowid("MM VOLUME SLIDER");
  tempo = getwindowid("MM TEMPO SLIDER");
  key0 = getwindowid("MM KEY0");
  key1 = getwindowid("MM KEY1");
  key2 = getwindowid("MM KEY2");
  key3 = getwindowid("MM KEY3");
  key4 = getwindowid("MM KEY4");
  key5 = getwindowid("MM KEY5");
  key6 = getwindowid("MM KEY6");
  key7 = getwindowid("MM KEY7");
  key8 = getwindowid("MM KEY8");
  key9 = getwindowid("MM KEY9");
  filename = getwindowid("MM FILENAME");
  voicename = getwindowid("MM NAME DISPLAY");
  load = getwindowid("MM LOADFILE");
  save = getwindowid("MM SAVEFILE");
  midia = getwindowid("MM MIDI A");
  midib = getwindowid("MM MIDI B");
  midic = getwindowid("MM MIDI C");
  midistop = getwindowid("MM MIDI STOP");
  midireset = getwindowid("MM MIDI RESET");
  fmreset = getwindowid("MM FM RESET");
  copy = getwindowid("MM COPY");
  paste = getwindowid("MM PASTE");

  w = -1 ;
  while(w != quit) {
    if(newvoice) {               // install the new voice
      v = &voicelist[cur_voice];
                                 // First, the radio buttons
      setradio("MM AMP MOD 1",&v->data[0],7);
      setradio("MM AMP MOD 2",&v->data[1],7);
      drawwindow("MM AMP MOD 1");
      drawwindow("MM AMP MOD 2");
      setradio("MM VIB 1",&v->data[0],6);
      setradio("MM VIB 2",&v->data[1],6);
      drawwindow("MM VIB 1");
      drawwindow("MM VIB 2");
      setradio("MM SUS 1",&v->data[0],5);
      setradio("MM SUS 2",&v->data[1],5);
      drawwindow("MM SUS 1");
      drawwindow("MM SUS 2");
      setradio("MM KSC 1",&v->data[0],4);
      setradio("MM KSC 2",&v->data[1],4);
      drawwindow("MM KSC 1");
      drawwindow("MM KSC 2");
                                 // Now The sliders
      setslidervals("MM MFM SLIDER 1",v->data[0] & 0x0f,0,15,1,slidercb);
      prepslider("MM MFM DISPLAY 1","MM MFM SLIDER 1");
      setslidervals("MM MFM SLIDER 2",v->data[1] & 0x0f,0,15,1,slidercb);
      prepslider("MM MFM DISPLAY 2","MM MFM SLIDER 2");

      setslidervals("MM SCL SLIDER 1",(v->data[2] & 0xc0)>>6,0,3,1,slidercb);
      prepslider("MM SCL DISPLAY 1","MM SCL SLIDER 1");
      setslidervals("MM SCL SLIDER 2",(v->data[3] & 0xc0)>>6,0,3,1,slidercb);
      prepslider("MM SCL DISPLAY 2","MM SCL SLIDER 2");

      setslidervals("MM ATR SLIDER 1",(v->data[4] & 0xF0)>>4,0,15,1,slidercb);
      prepslider("MM ATR DISPLAY 1","MM ATR SLIDER 1");
      setslidervals("MM ATR SLIDER 2",(v->data[5] & 0xF0)>>4,0,15,1,slidercb);
      prepslider("MM ATR DISPLAY 2","MM ATR SLIDER 2");

      setslidervals("MM DCR SLIDER 1",(v->data[4] & 0x0f),0,15,1,slidercb);
      prepslider("MM DCR DISPLAY 1","MM DCR SLIDER 1");
      setslidervals("MM DCR SLIDER 2",(v->data[5] & 0x0f),0,15,1,slidercb);
      prepslider("MM DCR DISPLAY 2","MM DCR SLIDER 2");

      setslidervals("MM STL SLIDER 1",(v->data[6] & 0xF0)>>4,0,15,1,slidercb);
      prepslider("MM STL DISPLAY 1","MM STL SLIDER 1");
      setslidervals("MM STL SLIDER 2",(v->data[7] & 0xF0)>>4,0,15,1,slidercb);
      prepslider("MM STL DISPLAY 2","MM STL SLIDER 2");

      setslidervals("MM RER SLIDER 1",(v->data[6] & 0x0f),0,15,1,slidercb);
      prepslider("MM RER DISPLAY 1","MM RER SLIDER 1");
      setslidervals("MM RER SLIDER 2",(v->data[7] & 0x0f),0,15,1,slidercb);
      prepslider("MM RER DISPLAY 2","MM RER SLIDER 2");

      setslidervals("MM FDB SLIDER",(v->data[8] & 0x0e)>>1,0,7,1,slidercb);
      prepslider("MM FDB DISPLAY","MM FDB SLIDER");

      setradio("MM MOD SELECT",&v->data[8],0);
      drawwindow("MM MOD SELECT");

      setslidervals("MM NAME SLIDER",cur_voice,0,127,1,slidercb);
  		prepslider("MM NAME DISPLAY","MM NAME SLIDER");

      setslidervals("MM VOLUME SLIDER",midi_volume,0,0x3f,1,slidercb);
  		prepslider("MM VOLUME DISPLAY","MM VOLUME SLIDER");

      setslidervals("MM TEMPO SLIDER",200-midi_usertempo,1,200,1,slidercb);
  		prepslider("MM TEMPO DISPLAY","MM TEMPO SLIDER");

      setslidervals("MM WFS SLIDER 1",(v->data[9] & 0x03),0,3,1,slidercb);
      prepslider("MM WFS DISPLAY 1","MM WFS SLIDER 1");
      setslidervals("MM WFS SLIDER 2",(v->data[10] & 0x03),0,3,1,slidercb);
      prepslider("MM WFS DISPLAY 2","MM WFS SLIDER 2");

      sprintf(string,"cc%s",voice_filename);
      setwintext("MM FILENAME",string);
      drawwindow("MM FILENAME");
    	newvoice = 0;
    }
    															// Make sure all voices are set
  	for(i = 0; i < 9; i++) {
      FMSetVoice(i,v->data);
    }
  	                             // Play a note
    if(playnote) {
      FMKeyOff(channel);
      FMSetNote(channel,note);
      FMSetVoice(channel,v->data);
      FMSetVolume(channel,midi_volume);
      FMKeyOn(channel);
      playnote = 0;
    }

                                 // update the Hex dispaly of the voice
		buildhex(string,v);
    setwintext("MM VOICE HEX",string);
    drawwindow("MM VOICE HEX");


  	if(w > -1) w = mouseloop(&x,&y);
    else w = load;
                                 // Handle all the different sliders
    if(w == mfm1) {
    	i = doslider("MM MFM SLIDER 1"); // do the slider and get a number back
      v->data[0] = (v->data[0] & 0xF0) | i; // set the data properly
    }
    else if(w == mfm2) {
    	i = doslider("MM MFM SLIDER 2");
      v->data[1] = (v->data[1] & 0xF0) | i;
    }
    else if(w == scl1) {
    	i = doslider("MM SCL SLIDER 1");
      v->data[2] = (v->data[2] & 0x3f) | i<<6;
    }
    else if(w == scl2) {
    	i = doslider("MM SCL SLIDER 2");
      v->data[3] = (v->data[3] & 0x3f) | i<<6;
    }
    else if(w == atr1) {
    	i = doslider("MM ATR SLIDER 1");
      v->data[4] = (v->data[4] & 0x0f) | i<<4;
    }
    else if(w == atr2) {
    	i = doslider("MM ATR SLIDER 2");
      v->data[5] = (v->data[5] & 0x0f) | i<<4;
    }
    else if(w == dcr1) {
    	i = doslider("MM DCR SLIDER 1");
      v->data[4] = (v->data[4] & 0xf0) | i;
    }
    else if(w == dcr2) {
    	i = doslider("MM DCR SLIDER 2");
      v->data[5] = (v->data[5] & 0xf0) | i;
    }
    else if(w == stl1) {
    	i = doslider("MM STL SLIDER 1");
      v->data[6] = (v->data[6] & 0x0f) | i<<4;
    }
    else if(w == stl2) {
    	i = doslider("MM STL SLIDER 2");
      v->data[7] = (v->data[7] & 0x0f) | i<<4;
    }
    else if(w == rer1) {
    	i = doslider("MM RER SLIDER 1");
      v->data[6] = (v->data[6] & 0xf0) | i;
    }
    else if(w == rer2) {
    	i = doslider("MM RER SLIDER 2");
      v->data[7] = (v->data[7] & 0xf0) | i;
    }
    else if(w == fdb) {
    	i = doslider("MM FDB SLIDER");
      v->data[8] = (v->data[8] & 0xf1) | i<<1;
    }
    else if(w == wfs1) {
    	i = doslider("MM WFS SLIDER 1");
      v->data[9] = (v->data[9] & 0xfc) | i;
    }
    else if(w == wfs2) {
    	i = doslider("MM WFS SLIDER 2");
      v->data[10] = (v->data[10] & 0xfc) | i;
    }
    else if(w == volume) {
    	midi_volume = doslider("MM VOLUME SLIDER");
    }
    else if(w == tempo) {
    	midi_usertempo = doslider("MM TEMPO SLIDER");
    }
    else if(w == voice) {
    	cur_voice = doslider("MM NAME SLIDER");
      newvoice = 1;
    }
    else if(w == key0) {
			note = 114;
      playnote = TRUE;
    }
    else if(w == key1) {
			note = 24;
      playnote = TRUE;
    }
    else if(w == key2) {
			note = 34;
      playnote = TRUE;
    }
    else if(w == key3) {
			note = 44;
      playnote = TRUE;
    }
    else if(w == key4) {
			note = 54;
      playnote = TRUE;
    }
    else if(w == key5) {
			note = 64;
      playnote = TRUE;
    }
    else if(w == key6) {
			note = 74;
      playnote = TRUE;
    }
    else if(w == key7) {
			note = 84;
      playnote = TRUE;
    }
    else if(w == key8) {
			note = 94;
      playnote = TRUE;
    }
    else if(w == key9) {
			note = 104;
      playnote = TRUE;
    }
    else if(w == special) {
			vfile = fopen("coutput.txt","w");           // open file
    	if(vfile) {                                  // if that worked...
    		for(i = 0; i < 128; i++) {                 // loop through voices
        	//fprintf(vfile,"\t{");
/*        	for(j = 0; j < 11; j++) {                // write the data
          	fprintf(vfile,"0x%c%c",hexchar[voicelist[i].data[j]/16],
																	hexchar[voicelist[i].data[j]%16]);
            if( j < 10 ) fprintf(vfile,",");
        	}  */
          fprintf(vfile,"(%d) %s\n",i,voicelist[i].name);  // write the name
        }
        fclose(vfile);
      }
    }
    else if(w == save) {
			vfile = fopen(voice_filename,"w");           // open file
    	if(vfile) {                                  // if that worked...
    		for(i = 0; i < 128; i++) {                 // loop through voices
        	for(j = 0; j < 11; j++) {                // write the data
          	fprintf(vfile,"%c%c ",hexchar[voicelist[i].data[j]/16],
																	hexchar[voicelist[i].data[j]%16]);
        	}
          fprintf(vfile,"\"%s\"\n",voicelist[i].name);  // write the name
        }
        fclose(vfile);
      }
    }
    else if(w == load) {
			vfile = fopen(voice_filename,"r");           // open file
    	if(vfile) {                                  //  if it worked...
    		for(i = 0; i < 128; i++) {                 // loop through voices
        	for(j = 0; j < 11; j++) {                // loop through data
          	fscanf(vfile,"%X ",&(voicelist[i].data[j])); // grab data
        	}
          fgets(string,255,vfile);                 // grab name
          for(j  = 0; string[j] != '\"'; j++);     // strip quotes
          j++;
          for( k = 0; string[k+j] != '\"' ; k++) {
          	voicelist[i].name[k] = string[k+j];
          }
          voicelist[i].name[k] = 0;                // terminate string
        }
        fclose(vfile);
      }
      newvoice = 1;
    }
    else if(w == voicename) {
    	win = getwindow("MM NAME DISPLAY");
      setwintext("MM NAME DISPLAY","cc ");
      drawwindow("MM NAME DISPLAY");
    	getinput(win->x+5,win->y+4,win->tc,win->bc," ",v->name,31);
      newvoice = 1;
    }
    else if(w == filename) {
    	win = getwindow("MM FILENAME");
      setwintext("MM FILENAME","cc ");
      drawwindow("MM FILENAME");
    	getinput(win->x+5,win->y+4,win->tc,win->bc," ",voice_filename,13);
      newvoice = 1;
    }
    else if(w == fmreset) {
			FMReset();
    }
    else if(w == midia) {
    	MidiCommand(v_stop);
      midi_data = midi1;
    	MidiCommand(v_play);
    }
    else if(w == midib) {
    	midi_on = FALSE;
      midi_data = midi2;
      midi_reset = TRUE;
      midi_on = TRUE;
    }
    else if(w == midic) {
    	midi_on = FALSE;
      midi_data = midi3;
      midi_reset = TRUE;
      midi_on = TRUE;
    }
    else if(w == midistop) {
    	midi_on = FALSE;
    }
    else if(w == midireset) {
    	midi_reset = TRUE;
    }
    else if(w == copy) for(i = 0 ; i < 11; i++) storage[i] = v->data[i];
    else if(w == paste) {
			for(i = 0 ; i < 11; i++) v->data[i] = storage[i];
      newvoice = 1;
    }


  }

  FMReset();                             // Clean up and go home
  for(i = 0; i < 9; i++) {
		FMKeyOff(i);
		FMSetVoice (i,voicelist[cur_voice].data) ;
    FMSetVolume(i,0);
  }

}


/**************************************************************************
	void buildhex(char string[],VOICE *v)

  DESCRIPTION:  Builds a Hexadecimal string to show voice vals.

  string	  -  preallocated output string
  v					-  voice to convert to hex

**************************************************************************/
void buildhex(char string[],VOICEDEF *v)
{
	int i;

  sprintf(string,"cc");
  for(i = 0; i < 11; i++) {
  	string[i*3+2] = hexchar[v->data[i]/16];
  	string[i*3+3] = hexchar[v->data[i]%16];
  	string[i*3+4] = ' ';
  }
  string[i*3+2] =0;

}

/**************************************************************************
	void slidercb(WINDOW *sw)

  DESCRIPTION: Callback routin for the sliders.  Puts value of the slider
  						 into the text of a child window.

**************************************************************************/
void slidercb(WINDOW *sw)
{
	char string[255],*child;
	long int *val,*min,*max,*inc;
	WINDOW *win;

	val = &(sw->intdata[0]);
	min = &(sw->intdata[1]);
	max = &(sw->intdata[2]);
	inc = &(sw->intdata[3]);

	if(sw->child) {                       // If there is a child win for display
		child = (sw->child)->name;          // Get name of child window
    if(WINDOW_IS("MM NAME DISPLAY")) {
    	sprintf(string,"cc%s",voicelist[*val].name);
      setwintext(child,string);
      drawwindow(child);
    }
    else {
		  sprintf(string,"cc%ld",*val);       // set text to value
		  setwintext(child,string);           // Copy trext to window structure
		  drawwindow(child);                  // Draw it!
    }
	}
}

