/**************************************************************************

	VARMINT WINDOWS (0.0)

	This is just an extremely crude hack for making buttons and stuff.
	It isn't the best code around, but it sure saved me a lot of time
	and headaches.

	Written by:  Eric Jorgensen (1994)

	TODO
		[ ]	Convert slider functions to inline
			[ ] use internal intergers
			[ ] use callbacks
		[x] Add backing store capability
		[x] Add bitmap face capabiity
		[ ] Change button look
			[ ] update button press engine
		[ ] eliminate use of getpress()
			[ ] add dump_on_press variable to structure
		[ ] implement child windows.
			[ ] Add array pointer to structure
			[ ] add functionality to readwindows()
		[x] new radio button drawing
    	[x] Bit pointer for radio button
      [x] bitwise functions
		[ ] add graphics_on detection in errorandler
    [x] expand slider  code to handle verticle sliders
    [x] callback funtion for mouseloop

	TOFIX

  	[x] Spinner appearance

***************************************************************************/

#include "windows.h"
												/* globals :( */
int graphics_on = FALSE;
extern int errno;
WINDOW *windows = NULL;
char errstring[256];
int current_exposure = 1;
WINDOW *wtest, *debugwin;
int	return_number = 1;                   // internal window id index
int return_hold;												 // internal global to keep track
																				 // of the window selected by
																				 // get otkeywin();


												/* local funcs */
int getstring(FILE *file,char string[]);
void displaywindows(void);
WINDOW *lowestwin(int low);
WINDOW *findwindow(char *win);
int tokenize(char *buffer, char*token[]);
WINDOW *gethotkeywin(void);



/**************************************************************************
	void initwindows(void)

	DESCTRIPTION: This function doesn't really do anything essential.
								It just puts of the logo and sets the internal graphhics
								flag to ON so the library will work.

**************************************************************************/
void initwindows(void)
{
	WINDOW *win;

	graphics_on = TRUE;

																// make sure error windows are available
	win = findwindow("ERROR");
	if(!win) addwindow("ERROR",10,10,500,300,WINTYPE_PLAQUE,
					"clAN ERROR HAS OCCURED");

	win = findwindow("ERROROK");
	if(!win) addwindow("ERROROK",250,275,40,25,WINTYPE_BUTTON,
					"ccOK");
	win = findwindow("ERROROK");
	win->hotn = 0;
  win->hotc = 'O';

	win = findwindow("VARMINT LOGO");
	if(!win) addwindow("VARMINT LOGO",10,10,150,20,WINTYPE_PLAQUE,
					"ccVARMINT WINDOWS");

	drawwindow("VARMINT LOGO");
	hidewindows();

	delay(1000);

}



/**************************************************************************
	WINDOW *getwinfromid(int id)

	DESCTRIPTION: returns a window structure from an id

**************************************************************************/
WINDOW *getwinfromid(int id)
{
	WINDOW *head;

	head = windows;               // get ready for search. Default value is NULL

	while(head)                   /* run through the list */
		{
			if(head->ret == id) break;  // is this the window?

			head = head->next;
		}                           // move down the list

	return head;
}

/**************************************************************************
	void setcallback(char *window,void (*callback)())

	DESCTRIPTION:  sets the callback variable in specified window structure

**************************************************************************/
void setcallback(char *window,void (*callback)())
{
	WINDOW *w;

	w = findwindow(window);
	if(!w) {
		sprintf(errstring,"setcallback(): Cannot find window '%s'",window);
		errorhandler(1,errstring);
	}

	w->callback = callback;
}
/*************************************************************************
	addwindow(name,x,y,w,h,type,text);

	DESCRIPTION:  Adds a window to the winow list

**************************************************************************/
WINDOW *addwindow(char *name,int x,int y,int w,int h,int type,char *text)
{
	WINDOW *addme;

	if(!name) errorhandler(1,"addwindow():  Null name pointer");

	addme = MALLOC(WINDOW);                  // make a new window
	if(!addme) {
		sprintf(errstring,"addwindow():  out of memory");
		errorhandler(1,errstring);
	}


	addme->name = CALLOC(strlen(name),char); // assign name
	if(!addme->name) {
		sprintf(errstring,"addwindow():  out of memory");
		errorhandler(1,errstring);
	}
	strcpy(addme->name,name);

	addme->x = x;                            // assign geometry
	addme->y = y;
	addme->w = w;
	addme->h = h;

	addme->type = type;                      // assign type

	if(strlen(text))	{                      // assign text, if any
			addme->text = CALLOC(strlen(text),char);  // make room
			if(!addme->text) {
				sprintf(errstring,"addwindow():  out of memory");
				errorhandler(1,errstring);
			}
			strcpy(addme->text,text);            // copy text over
		}
	else addme->text = NULL;

	addme->ret = return_number;              // set return value

	return_number ++;                        // advance internal return counter
																					 // set defaults
	addme->callback = NULL;
	addme->exposure = UNEXPOSED;
	addme->tc = TEXTCOLOR;                   // colors
	addme->thc = TEXTHIGHLIGHTCOLOR;
	addme->hc = HIGHLIGHTCOLOR;
	addme->sc = SHADOWCOLOR;
	addme->bc = BACKGROUNDCOLOR;
	addme->hotn = 0;                         // hotkey
	addme->hotc = 0;
	addme->dump_on_press = FALSE;
	addme->background  = NULL;
	addme->icon = NULL;
	addme->icon_fillstyle = CENTER;
	addme->child = NULL;
	addme->sibling = NULL;
	addme->parent = NULL;
  addme->intpointer = NULL;

	addme->next = windows;                   	// add new window to list
	windows = addme;
	return addme;
}


/*************************************************************************
	doslider(sliderwin);

	DESCRIPTION:  General slider handler.  Returns data[0];

		INTDATA USAGE:
			[0]		current value
			[1]		Low value
			[2]		High Value
			[3]		increment


**************************************************************************/
long int doslider(char *sliderwin)
{
	int ox,x,y,buttons,s;
	long int *val,*low,*high,*inc;
	double c;
	char string[50];
	WINDOW *sw;
	double sfactor;

																						// Get a handle to the slider
																						// window structure.
	sw = findwindow(sliderwin);
	if(!sw) {
		sprintf(errstring,"doslider(): Cannot find window '%s'",sliderwin);
		errorhandler(1,errstring);
	}

	val = &(sw->intdata[0]);                  // slider operating parameters
	low = &(sw->intdata[1]);
	high = &(sw->intdata[2]);
	inc = &(sw->intdata[3]);
	sfactor = 1000.0/(((double)*high-*low) / *inc);

	VW_mousestatus(&x,&y,&buttons);           // start with the mouse

	while(buttons) {
		s = getsliderstatus(sliderwin,x,y);   			 // find position
		if(s == -1) {                           		 // left button pushed
			getrelease(&x,&y);                    		 // wait for a release
			if(getsliderstatus(sliderwin,x,y) == -1) { // same button?
				*val -= *inc;												     // decrement internal value
				if(*val < *low)*val = *low;              // bounds check

																								 // update the slider
				s = (((double)*val-*low)/(*high-*low))*1000.0;
				updateslider(sliderwin,s);

				if(sw->callback) sw->callback(sw);  // do callcack if there is one
			}
			buttons = 0;
		}
		if(s == -2) {                           // right button pushed
			getrelease(&x,&y);                    // wait for a release
			if(getsliderstatus(sliderwin,x,y) == -2) { // same button?
				*val += *inc;												     // decrement internal value
				if(*val > *high)*val = *high;              // bounds check

																								 // update the slider
				s = (((double)*val-*low)/(*high-*low))*1000.0;
				updateslider(sliderwin,s);

				if(sw->callback) sw->callback(sw);  // do callcack if there is one
			}
			buttons = 0;
		}
		ox = -1;                                // ox keeps track of mouse movement
		while(buttons) {                        // while a button is being pressed
			if(s >= 0 && x != ox) {               // cursor moved and in slider area?
				ox = x;                             // reset old x value

				updateslider(sliderwin,s);          // redraw slider
				*val = ((int)(s/sfactor+0.5)) * *inc + *low;
				if(sw->callback) sw->callback(sw);  // do callcack if there is one

			}
			VW_mousestatus(&x,&y,&buttons);          // get new mouse position
			s = getsliderstatus(sliderwin,x,y); // get slider value
		}
	}
	s = (((double)*val-*low)/(*high-*low))*1000.0;
	updateslider(sliderwin,s);

	return (*val);
}



/**************************************************************************
	void setslidervals(sliderwin,val,low,high,inc,callback)

	DESCTRIPTION: Set the values used internally by the slider function

			INTDATA USAGE:
			[0]		current value
			[1]		Low value
			[2]		High Value
			[3]		increment

**************************************************************************/
void setslidervals(char *sliderwin, long int val,long int low,
										long int high,long int inc,void (*callback)())
{
	setintdata(sliderwin,0,val);
	setintdata(sliderwin,1,low);
	setintdata(sliderwin,2,high);
	setintdata(sliderwin,3,inc);
	setcallback(sliderwin,callback);
}

/*************************************************************************
	prepslider(textwin,swin);

	DESCRIPTION:  This saves a little code space when drawing sliders

	textwin = label window (optional)
	swin = slider window

**************************************************************************/
int prepslider(char *textwin, char *swin)
{
	WINDOW *sw;
	long int *val,*low,*high;

	if(!swin) return(0);                    // swin required


	sw = findwindow(swin);
	if(!sw) {
		sprintf(errstring,"prepslider(): Cannot find window '%s'",swin);
		errorhandler(1,errstring);
	}

	val = &(sw->intdata[0]);
	low = &(sw->intdata[1]);
	high = &(sw->intdata[2]);

	if(textwin) drawwindow(textwin);				// draw label

	if(sw->callback) {
		sw->callback(sw);
	}

	drawwindow(swin);                       // draw the slider
	updateslider(swin,((double)*val-*low)/(*high-*low) * 1000.0);
	return (getwindowid(swin));
}
/**************************************************************************
	getinput(x,y,fc,bc,prompt,string,maxlength);

	DESCRIPTION: This gets string input from the user. This function
							 fills the variable 'string' with text information.
							 If string already has text information in it, getinput()
							 will use it.

	fc,bc = 		foregroundcolor, backgroundcolor

**************************************************************************/
void getinput(int x,int y,int fc,int bc,
			char *prompt,char *string,int maxlength)
{
	int w,h,p,wx,wy,wr,pl,i,j,k,c,flag,dd=0,color;
	char buffer[255],r,minibuff[2];

	VW_hidemouse();                       // Get rid of mouse cursor
	minibuff[1] = 0;                      // clear small string buffer

	w = VW_textwidth("A");
	h = VW_textheight("A");
	wx = x+VW_textwidth(prompt);          // get location if leftmost input char
	wy = y;

	sprintf(buffer,"%s%s",prompt,string);
	VW_outtextxy(fc,x,y,buffer);          // display prompt and default string

	strcpy(buffer,string);     						// copy string for editing */

	c = strlen(buffer);
	flag = 1;

	while(flag) {                          	// ANIMATED STRING EDITOR LOOP
		if(dd > 100) color = fc;       	 		 	// Blink cursor
		else color = bc;
		VW_bar(color,wx+c*w, wy, wx+c*w+w, wy+h); // draw cursor

		delay(10);                        		// control blink rate
		dd += 5;
		if(dd > 199) dd = 0;

		r = inkey();
		if(r) {                      					// look for a key stroke
			if( r >= ' ') {           					// If r is a regular alpha-numeric
																					// character, add it to the name
																					// string.
				buffer[c] = r;
																					// move the cursor
				VW_bar(bc,wx+c*w,wy,wx+c*w+w,wy+h);   // erase it
				VW_bar(bc,wx,wy,wx+maxlength*w+w,wy+h); 		 // erase string
				buffer[c+1] = 0;              		// extend string terminator
				VW_outtextxy(fc,wx,wy,buffer); 		// draw the new string
				c++;                      				// move cursor index
				if(c>maxlength) c = maxlength;// limit string length
			}
			else if(r == 13) flag = 0;    			// return = finished
			else if( r == 8) {             			// backspace
				VW_bar(bc,wx+c*w,wy,wx+c*w+w,	wy+h);  // erase cursor
				c--;                      				// move string index
				if(c < 0) c = 0;          				// don't go off te end!
				buffer[c] = 0;            				// move back string terminator
				VW_bar(bc,wx+w,wy,wx+maxlength*w+w,wy+h);  // erase string
				VW_outtextxy(fc,wx,wy,buffer); 		// draw the new string
			}
			else if(r == 27)	{									// escape key
				flag = 0;                         // end loop
				buffer[0] = 0;                    // clear input string
			}
		}
	}
	strcpy(string,buffer);                  // store new string
	*(string+maxlength) = 0;                // make sure string is of this length
	VW_showmouse();                         // bring mouse cursor back
}


/**************************************************************************
	void setradio(char *win,int *pointer,int bitnum)

  DESCRIPTION: Tells radio button which bit it is controlled by.

**************************************************************************/
void setradio(char *win,int *pointer,int bitnum)
{
	WINDOW *w;

	w = findwindow(win);            	// get the window handle
	if(!w) {                         	// If window does not exist..
		sprintf(errstring,"setradio(): Could not find window %s",win);
		errorhandler(1,errstring);
	}

  w->intpointer = pointer;
  w->intdata[0] = bitnum;
}

/**************************************************************************
	toggleradio(win);

	DESCRIPTION: This toggles the value of a radio button.

  Note: you must call setradio() before you can use this function

**************************************************************************/
int toggleradio(char *win)
{
	WINDOW *w;
  int bit= 1;

	w = findwindow(win);            // get the window handle
	if(!w) {                        // If window does not exist..
		sprintf(errstring,"toggleradio(): Could not find window %s",win);
		errorhandler(1,errstring);
	}

  if(!w->intpointer) return -1;   // setradio() must be called first

  bit <<= w->intdata[0];					// make an XOR bitmask
  *w->intpointer ^= bit;          // Toggle our special bit

	blankwindow(win,w->bc);
	drawwindow(win);                // draw the new window
	return *w->intpointer & bit;    // return a t/f value
}

/**************************************************************************
	DrawSlider(win);

	DESCRIPTION: This draws the slider tool.

**************************************************************************/
void DrawSlider(WINDOW *win)
{
	int x1,y1,x2,y2,a,b;
	int td,cx,cy;

	x1 = win->x;                         				// set slider dimensions
	y1 = win->y;
	x2 = win->x+win->w;
	y2 = win->y+win->h;

	a = BUTTONBORDERWIDTH * 3;         				// edge width
	td = win->h - a*2 - BUTTONBORDERWIDTH * 4;  // tool dimension

	DrawBox(win,BUTTONBORDERWIDTH);   // draw main body
	drawpit(x1+a+win->h,y1+a,x2-a-win->h,y2-a,BUTTONBORDERWIDTH,
					win->hc,win->sc,win->bc); // draw interior


	cx = x1+(win->h)/2;                       // determine center of left arrow
	cy = y1+(win->h/2);

	b = 3*td/4;                                 // arrow dimension
	VW_hidemouse();                           // get rid of mouse cursor

	VW_line(win->hc,cx-b,cy,cx+b,cy-b);         // draw left arrow
	VW_line(win->sc,cx+b,cy-b,cx+b,cy+b);
	VW_line(win->sc,cx+b,cy+b,cx-b,cy);

	cx = x2-(win->h)/2;                       // determine center of right arrow
	cy = y2-(win->h/2);

	VW_line(win->sc,cx+b,cy,cx-b,cy-b);         // draw right arrow
	VW_line(win->hc,cx-b,cy-b,cx-b,cy+b);
	VW_line(win->sc,cx-b,cy+b,cx+b,cy);

	VW_showmouse();                           // bring back mouse
}
/**************************************************************************
	getsliderstatus(win,x,y);

	DESCRIPTION: This updates the appearance of a slider tool and returns a
							 normalized value of the slider positio.  (0-1000);

**************************************************************************/
int getsliderstatus(char *win,int x, int y)
{
	int a,b,td,tx,x1,y1,x2,y2,r;
	WINDOW *w;

	w = findwindow(win);            					// get the window handle
	if(!w) {                         					// If window does not exist..
		sprintf(errstring,"GetSliderStatus(): Could not find window %s",win);
		errorhandler(1,errstring);
	}

	x1 = w->x;                         				// set slider dimensions
	y1 = w->y;
	x2 = w->x+w->w;
	y2 = w->y+w->h;

	a = BUTTONBORDERWIDTH * 3;         				// edge width
	td = w->h - a*2 - BUTTONBORDERWIDTH * 6;  // tool dimension

	b = w->w - a - w->h*2-td-BUTTONBORDERWIDTH*8;// interior dimension

	if(y >= y1 && y <= y2) {
		if(x>x1 && x < x1 + a + w->h) return (-1); // left button
		if(x>x2-a-w->h && x < x2) return (-2);     // right button
	}

	x -= td/2;
	r = x-x1-a-w->h-BUTTONBORDERWIDTH*2;     // else get tool position
	if(r < 0) r = 0;
	if(r > b) r = b;

	return(((double)r/b)*1000);              // return normalized position
}
/**************************************************************************
	updateslider(win,val);

	DESCRIPTION: This updates the appearance of a slider tool.

**************************************************************************/
void updateslider(char *win,int val)
{
	int a,b,td,ty,tx,x1,y1,x2,y2;
	WINDOW *w;


	w = findwindow(win);            // get the window handle
	if(!w) {                         // If window does not exist..
		sprintf(errstring,"UpdateSlider(): Could not find window %s",win);
		errorhandler(1,errstring);
	}

	if(val < 0 || val > 1000) {     // make sure point is in proper range
		sprintf(errstring,"UpdateSlider(): Invalid setpoint: %d",val);
		errorhandler(1,errstring);
	}

	x1 = w->x;                         				// set slider dimensions
	y1 = w->y;
	x2 = w->x+w->w;
	y2 = w->y+w->h;

	a = BUTTONBORDERWIDTH * 3;         				// edge width
	td = w->h - a*2 - BUTTONBORDERWIDTH * 2;  // tool dimension
	ty = y1+a+BUTTONBORDERWIDTH;            // tool y value

	b = w->w - a - w->h*2-td - BUTTONBORDERWIDTH*5;  // interior dimension
																						// x position
	tx = ((double)val/1000.0 * b) ;
	tx += x1 +a+w->h+BUTTONBORDERWIDTH;

	VW_hidemouse();
	VW_bar(w->bc,x1+a+w->h+1,y1+a+1,x2-a-w->h-1,y2-a-1); // erase tool
	VW_showmouse();
	drawbox(tx,ty,tx+td,ty+td,BUTTONBORDERWIDTH,
					w->hc,w->sc,w->bc); // draw the tool
}



/**************************************************************************
	blankwindow(win,color);

	DESCRIPTION: fills in the window area with a specified color.

**************************************************************************/
void blankwindow(char *win,int color)
{
	WINDOW *w;

	w = findwindow(win);            // get window handle
	if(!w)                          // if window does  not exist...
		{
			sprintf(errstring,"blankwindow(): Could not find window %s",win);
			errorhandler(1,errstring);
		}

	VW_hidemouse();                 // get mouse cursor out of the way
	VW_bar(color,w->x,w->y,w->x+w->w,w->y+w->h);  // blank the window

	hidewindow(win);                // reset the exposure level
	VW_showmouse();                 // bring back the mouse
}

/**************************************************************************
setwincolors(win,tc,thc,hc,sc,bc);

	DESCRIPTION: sets the colors of a window strincture

	tc	textcolor
	thc	texthighlightcolor
	hc	highlightcolor
	sc	shadowcolor
	bc	backgroundcolor

**************************************************************************/
void setwincolors(char *win,int tc,int thc, int hc,int sc,int bc)
{
	WINDOW *w;

	w = findwindow(win);            // get the window handle
	if(!w)                          // If window does not exist..
		{
			sprintf(errstring,"setwincolors(): Could not find window %s",win);
			errorhandler(1,errstring);
		}
	w->tc = tc;
	w->thc = thc;
	w->hc = hc;
	w->sc = sc;
	w->bc = bc;
}

/**************************************************************************
setwintext(win,string);

	DESCRIPTION: sets the text string portion of a window strincture

**************************************************************************/
void setwintext(WINDOW *win, char *string)
{
	WINDOW *w;

	w = findwindow(win);            // get the window handle
	if(!w)                          // If window does not exist..
		{
			sprintf(errstring,"setwintext(): Could not find window %s",win);
			errorhandler(1,errstring);
		}
	free(w->text);                  // get rid of old text
	w->text = CALLOC(strlen(string),char);  // allocate memory for new text
	strcpy(w->text,string);         // set the new text
}
/**************************************************************************
	int readwindows(winfilename)

	DESCRIPTION:  Reads in window defs from specified file

	INPUTS:
		winfile	name of winfile to read in

	RETURNS: error code

		0				No errors
		-1			No such file
		-2			No such type in winfile
		-3			premature end of file

*************************************************************************/
int readwindows(char *winfilename)
{
	FILE *winfile;
	WINDOW *win;
	char buffer[512],hc;
	int err;
	int i,x,y,w,h,typn,numtokens,hk= -1;
	char name[255],text[255],type[50],*token[64];


	winfile = fopen(winfilename,"r");    // open the windows file
	if(!winfile)                         // oops! no file...
		{
			return(-1);
		}

	while(fgets(buffer,500,winfile))	{    // read until EOF
		numtokens = tokenize(buffer,token);// break up string

		if(numtokens >= 7) {               // make sure there is enough info
			strcpy(name,token[0]);           // get name for handle access
			x = atoi(token[1]);              // get geometry
			y = atoi(token[2]);
			w = atoi(token[3]);
			h = atoi(token[4]);
			strcpy(text,token[5]);
																			 // look for hotkey
			hk = -1;
			for(i = 0; i < strlen(text); i++) if(text[i] == '~') hk = i;
			if(hk >= 0) {                    // if hot key secified
				strcpy(&text[hk],&text[hk+1]); // take out special char
				hc = text[hk];								 // set the char value
			}

			strcpy(type,token[6]);

			if(!strcmp(type,"BUTTON")) 				typn = WINTYPE_BUTTON;
			else if(!strcmp(type,"FIELD")) 		typn = WINTYPE_FIELD;
			else if(!strcmp(type,"AREA")) 		typn = WINTYPE_AREA;
			else if(!strcmp(type,"PLAQUE")) 	typn = WINTYPE_PLAQUE;
			else if(!strcmp(type,"RADIO")) 		typn = WINTYPE_RADIO;
			else if(!strcmp(type,"SPINNER"))	typn = WINTYPE_SPINNER;
			else if(!strcmp(type,"SLIDER")) 	typn = WINTYPE_SLIDER;
			else if(!strcmp(type,"VALUEPIT")) typn = WINTYPE_VALUEPIT;
			else if(!strcmp(type,"LABEL")) 		typn = WINTYPE_LABEL;
			else {
				fclose(winfile);
				return(-2);
			}

			addwindow(name,x,y,w,h,typn,text);

      win = findwindow(name);
			if(!win) {
				printf("Readwindows(): Could not find window %s",win);
				errorhandler(1,errstring);
			}
                                       // sliders are handled outside mouseloop
      if(typn == WINTYPE_SLIDER) win->dump_on_press = 1;


			if(hk >=0) {                     // Set the Hot key
				win->hotn = hk;
				win->hotc = hc;
			}
			i = 7;
			while(i < numtokens) {
				if(!strcmp(token[i],"CHILDOF")) {
					setchild(token[i+1],token[0]);
					i += 2;
				}
        else i++;
			}
		}
	}

	fclose(winfile);
	//displaywindows();  // THIS IS FOR DEBUGGING
}



/**************************************************************************
	void setchild(char *parent, char *child)

	DESCTRIPTION: set proper variables in wondow structures to mainntain
								parent/child relationship.

**************************************************************************/
void setchild(char *parent, char *child)
{
	WINDOW *papa,*kiddo,*chhead;

	papa = findwindow(parent);
	if(!papa) {
		sprintf(errstring,"setchild(): Cannot find window '%s'",parent);
		errorhandler(1,errstring);
	}

	kiddo = findwindow(child);
	if(!kiddo) {
		sprintf(errstring,"setchild(): Cannot find window '%s'",child);
		errorhandler(1,errstring);
	}

	if(!papa->child) papa->child = kiddo;         // set child
	else {                                            // Has children! Find end
																										// of sibling list.
		chhead = papa->child;
		while(chhead->sibling) chhead = chhead->sibling;
		chhead->sibling = kiddo;
	}
	kiddo->parent = papa;                             // Papa!
}

/**************************************************************************
	int tokenize(char *buffer, char *token[])

	DESCTRIPTION: Takes a string and separates its compnents by adding null
								values to dice it up and setting token pointers.

**************************************************************************/
int tokenize(char buffer[], char *token[])
{
	int i= 0,tk=0,l;

	if(strlen(buffer) < 10) return(0);   // short lines treated as comments
	if(buffer[0] < '0' &&
		 buffer[0] != '\"') return(0);     // Miscellaneous punctuation = comment

	l = strlen(buffer);
	while(i < l) {
		if(buffer[i] == '\"') {            // check for literal string
			i++;                             // advance past quote
			token[tk] = &buffer[i];          // set token
			tk++;
			for(;buffer[i] != '\"'; i++);    // look for end of string
			buffer[i] = 0;									 // terminate token
			i++;
		}
		else if(buffer[i] <= ' ') i++;
		else {
			token[tk] = &buffer[i];          // set token
			tk++;
			for(;buffer[i] > ' '; i++);      // look for end of string
			buffer[i] = 0;									 // terminate token
			i++;
		}
	}

	return(tk);
}


/**************************************************************************
	int getstring(FILE *file, char *string)

	DESCRIPTION:	gets a string from a file. If the string is in
								quotes, it will get everything between the quotes.

	INPUTS:
		*file			pointer to file stream
		*string		pointer to character array

	RETURNS: none
*************************************************************************/
int getstring(FILE *file,char string[])
{
	int i;
	char r;

	string[0]  = 0;
	r = 0;
	i = 0;
	while(r <= ' ') fscanf(file,"%c",&r); // find next alphanumeric character

	if(r == '\"')                      /* quote delimited */
		{
			if(fscanf(file,"%c",&r)== EOF) return(-3);
			while(r != '\"')               // scan til next qote
				{
					string[i] = r;
					i++;
					fscanf(file,"%c",&r);
				}
		}
	else                               /* space delimited */
		{
			i = 1;
			string[0] = r;
			if(fscanf(file,"%c",&r) == EOF) return(-3);
			while(r != ' ' &&              // scan til next space
						r != '\n')
				{
					string[i] = r;
					i++;
					fscanf(file,"%c",&r);
				}
		}
	string[i] = NULL;
	return(0);
}

/**************************************************************************
		displaywindows();

		DESCRIPTION: This little function is for debugging.  It just writes
									data from the entire window list to the screen.

***************************************************************************/
void displaywindows(void)
{
	WINDOW *head;

	head = windows;
	while(head)
		{
			printf("name(%s)\n\tcoords(%d %d %d %d) exp/ret(%d %d) tt(%s %d)\n",
					head->name,
					head->x,head->y,head->w,head->h,
					head->exposure,head->ret,
					head->text,head->type);
			head = head->next;
		}
	getch();
}
/**************************************************************************
	void hidewindows(void)

	DESCRIPTION:	Sets exposure level to 0 for all windows

	INPUTS: none

	RETURNS: none
*************************************************************************/
void hidewindows(void)
{
	WINDOW *use;

	use = windows;                   // strat at teh head of the windows list
	while(use)                       // run down the links
		{
			use->exposure = UNEXPOSED;
			use = use->next;
		}
	current_exposure = 1;
}
/**************************************************************************
	void setintdata(char *win,int index,int number)

	DESCRIPTION:	Sets interger data in the window structure.
								This is intended for internal use.  ie: to keep
								track of wether to check the radio buttons or not.)

	INPUTS:
		*win		text string name of window to be exposed
		index		tells which of the five data slots to use
		number	value to store

	RETURNS: none
*************************************************************************/
void setintdata(char *win,int index,long int number)
{
	WINDOW *changeme;

	changeme = findwindow(win);    // get window handle

	if(!changeme)                  // oops, no window...
		{
			sprintf(errstring,"setintdata(): Could not find window \"%s\"",win);
			errorhandler(1,errstring);
		}
	if(index <0 || index > 4)      // there are only five  data slots
		{
			sprintf(errstring,"setintdata():  Index [%d] out of bounds",index);
			errorhandler(1,errstring);
		}

	changeme->intdata[index] = number;  // set the number
}


/**************************************************************************
	void exposewindow(char *win)

	DESCRIPTION:	Automatically sets exposure level for a specified window

	INPUTS:
		*win		text string name of window to be exposed

	RETURNS: none
*************************************************************************/
void exposewindow(char *win)
{
	WINDOW *exposeme,*use;
	int i;

	exposeme = findwindow(win);     				// get the window handle
	if(!exposeme)                     			// oops, no such window...
		{
			sprintf(errstring,"exposewindow(): unable to expose window %s\n",win);
			errorhandler(1,errstring);
		}

	exposeme->exposure = current_exposure;  // set the esposure
	current_exposure ++;                    // advance exposure level

	if(current_exposure > MAXEXPOSURE) {    // if exposure level is too high,
																					// sort the currently exposed
																					// windows and reexpose starting
																					// with 1.

		i = 0;
		use = lowestwin(i);                   // find lowest exposed window
		while(use) {                          // loop through all exposed windows
			i++;                                // advance exposure level
			use->exposure = i;                  // set exposure
			use = lowestwin(i);                 // find lowest exposed window with
																					// exposure > i
		}
		current_exposure = i+1;               // reset current exposure
	}
}
/**************************************************************************
 lowestwin(low);

 DESCRIPTION:  fuction used  by exposewindow to aid in sorting.  It returns
							a pointer to the window with the lowest exposure setting higher
							than (low).

**************************************************************************/
WINDOW *lowestwin(int low)
{
	WINDOW *use = windows,*lowest = NULL;
	int ll = MAXEXPOSURE;

	while(use)                  /* sort through window list */
		{
			if(use->exposure < ll && use->exposure > low)
				{
					lowest = use;       /* preserve window address */
					ll = use->exposure; // preserve lowest exposure so far
				}
			use = use->next;        // move to next window
		}
	return (lowest);            /* send back lowest window */
}

/**************************************************************************
	void hidewindow(char *win)

	DESCRIPTION:	Sets exposure level to UNNEXPOSED for a specified window

	INPUTS:
		*win		text string name of window to be hidden

	RETURNS: none
*************************************************************************/
void hidewindow(char *win)
{
	WINDOW *exposeme;

	exposeme = findwindow(win);     // get window handle
	if(!exposeme)                   // oops, no such window
		{
			sprintf(errstring,"hidewindow(): unable to hide window %s\n",win);
			errorhandler(1,errstring);
		}

	exposeme->exposure = UNEXPOSED; // set window exposure
}

/**************************************************************************
	void drawwindow(char *win)

	DESCRIPTION:	Draws a window

	INPUTS:
		*win		text string name of window to be drawn

	RETURNS: none
*************************************************************************/
void drawwindow(char *win)
{
	WINDOW *dome;
	int i,x,y,w,h,tx=0,ty=0;
	int x1,y1,x2,y2,bw;
	char hotkey[3];

	if(!graphics_on) {
		errorhandler(1,"drawwindow():  initwindows() has not been called.");
	}

	dome = findwindow(win);           // get window handle
	if(!dome) {                        // oops, no such window
		sprintf(errstring,"drawwindow():  Couldn't find window %s\n",win);
		errorhandler(1,errstring);
	}

																		/* draw the appropriate shape */
	switch(dome->type) {
		case WINTYPE_BUTTON:
			DrawBox(dome,BUTTONBORDERWIDTH);
			break;
		case WINTYPE_FIELD:
			DrawPit(dome,FIELDBORDERWIDTH);
			break;
		case WINTYPE_PLAQUE:
			DrawBox(dome,PLAQUEBORDERWIDTH);
			break;
		case WINTYPE_RADIO:
			DrawRadio(dome);
			break;
		case WINTYPE_SPINNER:
			DrawSpinner(dome);
			break;
		case WINTYPE_SLIDER:
			DrawSlider(dome);
			break;
		case WINTYPE_VALUEPIT:
			DrawPit(dome,BUTTONBORDERWIDTH);
			break;
		case WINTYPE_LABEL:
			DrawBox(dome,LABELBORDERWIDTH);
			break;
		default:
			break;
	}

																			/* put in text.  Note that the first
																				 two characters are x,y format
																				 signals
																					l = flush low
																					c = center
																					h = flush high */
	VW_hidemouse();                   	// get mouse cursor out of the way
	if(dome->text) {
		w = VW_textwidth(dome->text+2); 	// get text dimensions
		h = VW_textheight(dome->text+2);

																			// HORIZONTAL FORMATTING
		x = dome->x + VW_textwidth("A")/2; /* default = low flush */
		if(*(dome->text) == 'c')      		// center flush?
			x = dome->x + dome->w/2 - w/2;
		else if(*(dome->text) == 'h') 		// high flush?
			x = dome->x + dome->w - VW_textwidth("A")/2 - w;

																			// VERTICAL FORMATTING
		y = dome->y + VW_textheight("A")/2; /* default = low flush */
		if(*(dome->text+1) == 'c')        // center flush?
			y = dome->y + dome->h/2 - (h+1)/2;
		else if(*(dome->text+1) == 'h')   // high flush
			y = dome->y + dome->h - VW_textheight("A")/2 - h;

		VW_outtextxy(dome->tc,x,y,dome->text+2); // write it!

		if(dome->hotn) {                  // hot key defined?
			for(i = 2; i < dome->hotn; i++) {     // find out where this letter will be
				tx ++;
				if(dome->text == '\n') {
					tx = 0;
					ty ++;
				}
			}
			sprintf(hotkey,"%c",dome->hotc);// set hotkey string to print
			VW_outtextxy(dome->thc,x+tx*VW_textwidth("A"),
														y+ty*VW_textheight("A"),hotkey);

		}
	}
	VW_showmouse();                     // OK, mouse cursor can com back
	exposewindow(win);                  // We drew the window, now expose it

}

/**************************************************************************
	WINDOW *getwindow(char *win)

	DESCRIPTION:	Finds a window in the list of windows. External Version.
								Uses findwindow and reports an error if return is NULL.

	INPUTS:
		*win		text string name of window to be drawn

	RETURNS:
		pointer to window
*************************************************************************/
WINDOW *getwindow(char *win)
{
	WINDOW *w;

	w = findwindow(win);          // get window handle
	if(!w)                        // oops, no such window
		{
			sprintf(errstring,"getwindow(): Could not find window %s",win);
			errorhandler(1,errstring);
		}
	return (w);                   // send it on down...
}
/**************************************************************************
	WINDOW *findwindow(char *win)

	DESCRIPTION:	Finds a window in the list of windows.  Internal version.
								Does not check for NULL returns.

	INPUTS:
		*win		text string name of window to be drawn

	RETURNS:
		pointer to window
*************************************************************************/
WINDOW *findwindow(char *win)
{
	WINDOW *head;

	head = windows;               // get ready for search. Default value is NULL

	while(head)                   /* run through the list */
		{
			if(!strcmp(win,head->name)) break;  // is this the window?

			head = head->next;
		}                           // move down the list

	return head;
}

/**************************************************************************
	int getwindowid(char *win)

	DESCRIPTION:	Finds a window in the list of windows and returns its id

	INPUTS:
		*win		text string name of window to be drawn

	RETURNS:
		window id
*************************************************************************/
int getwindowid(char *win)
{
	WINDOW *w;

	w = findwindow(win);       // get window handle

	if(!w)                     // oops, no such window
		{
			sprintf(errstring,"getwindow(): Could not find window \"%s\"\n",win);
			errorhandler(1,errstring);
		}
	return w->ret;             // return with id
}
/**************************************************************************
	int inwindow(int x, int y)

	DESCRIPTION:	Takes an xy coordinate and looks for the highest exposed
								window that it is in.

	INPUTS:
		x,y		Coordinates of mouse press/release

	RETURNS:
		window id
*************************************************************************/
int inwindow(int x, int y)
{
	WINDOW *head, *hold;
	int exp = 0;

	head = windows;
	hold = NULL;

	while(head)                   		/* run through the list */
		{
			if(x > head->x && x < head->x + head->w &&  // in window?
				 y > head->y && y < head->y + head->h &&
				 head->exposure > exp)  		// highest exposure has priority
				 {
						exp = head->exposure;   // set highest exposure so far
						hold = head;            // hang on the the handle
				 }
			head = head->next;            // move down  the list
		}

	if(hold) return hold->ret;        // if there is a window, return it's id.
	else return 0;                 		// no window. return nothing.
}

/**************************************************************************
	int inwhatwindow(int x, int y)

	DESCRIPTION:	Takes an xy coordinate and looks for the highest exposed
								window that it is in.

	INPUTS:
		x,y		Coordinates of mouse press/release

	RETURNS:
		window address
*************************************************************************/
WINDOW *inwhatwindow(int x, int y)
{
	WINDOW *head, *hold;
	int exp = 0;

	head = windows;
	hold = NULL;

	while(head)                   		/* run through the list */
		{
			if(x > head->x && x < head->x + head->w &&  // in window?
				 y > head->y && y < head->y + head->h &&
				 head->exposure > exp)  		// highest exposure has priority
				 {
						exp = head->exposure;   // set highest exposure so far
						hold = head;            // hang on the the handle
				 }
			head = head->next;            // move down  the list
		}

	return (hold);								// return whatever we find;
}

/********************************************************************
	void DrawSpinner(win)

	DESCRIPTION:  Draws arrow boxes for a spinner

	INPUTS:
		x,y		upper left corner
		w,h		width, height

	RETURNS:  None

********************************************************************/
void DrawSpinner(WINDOW *win)
{
	int i,j,c;
	int x = win->x,y = win->y,w = win->w,h = win->h;

	                                 /* draw the buttons */
	drawbox(x,y,x+h,y+h,BUTTONBORDERWIDTH,win->hc,win->sc,win->bc);
	drawbox(x+h+1,y,x+h*2,y+h,BUTTONBORDERWIDTH,win->hc,win->sc,win->bc);

	VW_hidemouse();                  // bye bye, mouse cursor
																	 // UP ARROW
	VW_line(win->sc,x+h/4,y+2*h/3,x+3*h/4,y+2*h/3);
	VW_line(win->hc,x+h/4,y+2*h/3,x+h/2,y+h/3);
	VW_line(win->sc,x+h/2,y+h/3,x+3*h/4,y+2*h/3);
																	 // DOWN ARROW
	VW_line(win->hc,x+h+h/4,y+h/3,x+h+3*h/4,y+h/3);
	VW_line(win->sc,x+h+h/4,y+h/3,x+h+h/2,y+2*h/3);
	VW_line(win->sc,x+h+h/2,y+2*h/3,x+h+3*h/4,y+h/3);
	VW_showmouse();                  // bring back mouse cursor

}
/********************************************************************
	void DrawRadio(win)

	DESCRIPTION:  This draws a generic pyramid-type circle

	INPUTS:
		x,y			center
		radius
		state		Indicates wether radio is off or on

  Note: you need to call setradio() first

	RETURNS:  None

********************************************************************/
void DrawRadio(WINDOW *win)
{
	int h,i,j,c,gray_radius,midgray,x1,y1,x2,y2;
	double theta;
	int x = win->x,y = win->y,radius,state;

  if(!win->intpointer) return;    // need to call setradio() first

	h = win->h;
	radius = win->h*0.4;            // set up geometry
	state = *win->intpointer & 1 << win->intdata[0];

	midgray = GRAY0 + ((double)MAXGRAY/2.0 + 0.5);  // set up greyscale
	gray_radius = MAXGRAY/2;

	VW_hidemouse();                 // get rid of mouse cursor.

																	// This next part is a very inefficient
																	// bit of code for drawing a raised,
																	// pyramid-type circle.   But that is ok,
																	// because it's not like we have to draw
																	// a gazillion of them every microsecond
																	// or someting.

																	// erase any old button
	VW_bar(win->bc,win->x,win->y,win->x+win->h,win->y+win->h);

	for(theta = 0.0; theta  <= M_PI * 2.0; theta += M_PI/16.0) {
		x1 = x + radius * cos(theta) + h/2;
		y1 = y + radius * sin(theta)+h/2;
		x2 = x + radius * cos(theta + M_PI / 16.0)+h/2;
		y2 = y + radius * sin(theta + M_PI / 16.0)+h/2;
		VW_line(midgray+gray_radius * cos(theta - 5* M_PI/4.0),x1,y1,x2,y2);
	}


	if(state) {
			VW_circle(win->sc,x+h/2,y+h/2,radius*.5);
			VW_floodfill(win->sc,x+h/2,y+h/2,win->sc);
	}
	VW_showmouse();                 // bring mouse cursor back

}


/********************************************************************
	void DrawBox(win,int bw)

	DESCRIPTION:  This draws a generic pyramid-type grey rectangle


********************************************************************/
void DrawBox(WINDOW *win,int bw)
{
	int i,c;
	int x1 = win->x, y1 = win->y, x2 = win->x+win->w, y2 = win->y+win->h;

	if(win->type == WINTYPE_BUTTON) {
		VW_hidemouse();
		VW_line(DARKSHADOWCOLOR,x1+1,y1,x2-1,y1);
		VW_line(DARKSHADOWCOLOR,x2,y1+1,x2,y2-1);
		VW_line(DARKSHADOWCOLOR,x1,y1+1,x1,y2-1);
		VW_line(DARKSHADOWCOLOR,x1+1,y2,x2-1,y2);
		VW_showmouse();
		drawbox(x1+1,y1+1,x2-1,y2-1,bw,win->hc,win->sc,win->bc);
	}
	else drawbox(x1,y1,x2,y2,bw,win->hc,win->sc,win->bc);
}

/********************************************************************
	void DrawPit(win,int bw)

	DESCRIPTION:  This draws a generic pyramid-type(sunken) grey rectangle


********************************************************************/
void DrawPit(WINDOW *win,int bw)
{
	int i,c;
	int x1 = win->x, y1 = win->y, x2 = win->x+win->w, y2 = win->y+win->h;

	drawpit(x1,y1,x2,y2,bw,win->hc,win->sc,win->bc);
}
/*************************************************************************
	errorhandler(i,string);

	DESCRIPTION: simple errror handler.  Pops up an error window and waits for
							 Theuser to click on the ok button.

"ERROR"  							100	100	600	100	"clANERRO HAS OCCURRED" PLAQUE
"ERROROK"				 			340	170	20	20	"ccOK"								BUTTON

**************************************************************************/
void errorhandler(int i, char *string)
{
	WINDOW *win,*ewin;
	int e,w,h,flag=1,n;

	if(!graphics_on) {            // use text mode if no graphics
		printf("\nAN ERROR HAS OCCURED:\n%s\n",string);
		exit(i);
	}

	VW_hidemouse();               // get rid of mouse sursor
	e = getwindowid("ERROROK");   // get error window handle


	drawwindow("ERROR");          /* draw the window */
	drawwindow("ERROROK");

	win = findwindow("ERROR");    /* put in a centered error string */
	w = VW_textwidth(string);
	h = VW_textheight(string);
	VW_outtextxy(TEXTCOLOR,win->x+win->w/2-w/2,win->y+win->h/2-h/2,string);

	VW_showmouse();
	while(flag)										/* wait for the user to click OK */
		{
			n = getrelease(&w,&h);
			if(n == e) flag = 0;
		}

	exit(i);                      /* bye bye */
}


/**************************************************************************
	WINDOW *gethotkeywin(void)

	DESCTRIPTION:  Finds a window by comparing a keypress with hotkey values.

**************************************************************************/
WINDOW *gethotkeywin(void)
{
	char r;
	int exp= 0;
	WINDOW *w,*pick= NULL;

	r = toupper(getch());                 // get the keystroke

	w = windows;                          // start at te head of the list
	while(w) {
		if(w->exposure == UNEXPOSED) w = w->next;
		else {
			if(w->hotn) {
				if(r == toupper(w->hotc) && exp < w->exposure) {
					pick = w;
					exp  = pick->exposure;
				}
			}
			w = w->next;
		}
	}
	return(pick);
}

/********************************************************************
	int getpress(int *x, int *y)

	DESCRIPTION:  Waits for a press event and gives back
								coords and window id.

	INPUTS:
		*x			pointer to x coordinate int
		*y			pointer to y coordinate int

	RETURNS:  Id of window (if any) touched at press

********************************************************************/
int getpress(int *x, int *y)
{
	int bb,bw = BUTTONBORDERWIDTH,pressed=0;
	WINDOW *w,*ow,*hkw;


	VW_mousestatus(x,y,&bb);          			// initialize
	while (!bb) {                       		// wait for mouse/keyboard press
		VW_mousestatus(x,y,&bb);
		if(kbhit()) {                         // keypress? check for hotkey
			hkw = gethotkeywin();
			if(hkw) {                           // valid window?
				*x = -1;           								// keypress: coords invalid
				*y = -1;
				return_hold = hkw->ret;
				return(hkw->ret);                 // send id back
			}
		}
	}

	ow = inwhatwindow(*x,*y);               // get original window
																					// press the button if it is one
	return(ow->ret);
}

/********************************************************************
	int mouseloop(int *x, int *y)

	DESCRIPTION:  Automatic loop handler.  Gets mouse input, then
								calls functions and callbacks accordingly.

	INPUTS:
		*x			pointer to x coordinate int
		*y			pointer to y coordinate int

	RETURNS:  Id of window (if any) touched at release

********************************************************************/
int mouseloop(int *x, int *y)
{
	int bb,bw = BUTTONBORDERWIDTH,pressed=0;
	WINDOW *w,*ow,*hkw = NULL;

	VW_mousestatus(x,y,&bb);          			// initialize
	while (!bb) {                       		// wait for mouse/keyboard press
		VW_mousestatus(x,y,&bb);
		if(kbhit()) {                         // keypress? check for hotkey
			hkw = gethotkeywin();
			if(hkw) {                           // valid window?
				*x = hkw->x + hkw->w/2;           // set coordinates to center
				*y = hkw->y + hkw->h/2;
				bb = 1;
			}
		}
	}

	if(hkw) {
		ow = hkw;
		if(ow->dump_on_press) return(ow->ret);
	}
	else {
		ow = inwhatwindow(*x,*y);               // get original window
		if(ow->dump_on_press) return(ow->ret);
																						// if button, make it look pressed
		if(ow && ow->type == WINTYPE_BUTTON) buttonaction(ow,1,bw);
		pressed = 1;

		while (bb)                              // wait for mouse release
			{
				w = inwhatwindow(*x,*y);
				if(w != ow) {        								// window change?
					if(pressed) {
						pressed = 0;                      // unpress old win
						if(ow && ow->type == WINTYPE_BUTTON) buttonaction(ow,0,bw);
					}
				}
				else if(!pressed) {                 // in original window and not pressed?
					if(ow && ow->type == WINTYPE_BUTTON) buttonaction(ow,1,bw);
					pressed = 1;                      // mark pressed
				}
				VW_mousestatus(x,y,&bb);

			}

		if(w != ow) return(0);                  // not in a window.  return 0
	}

	if(ow) {                                // if there is an original window
		if(ow->type == WINTYPE_BUTTON) {
			buttonaction(ow,0,bw);  // release button
			if(ow->callback) ow->callback(ow);
		}
		else if(ow->type == WINTYPE_RADIO) {
			toggleradio(ow->name);   // toggle the radio button
			if(ow->callback) ow->callback(ow);
		}
		return ow->ret;                       // return id
	}
	else return(0);                         // must have been no window...
}
/********************************************************************
	int getrelease(int *x, int *y)

	DESCRIPTION:  Waits for a release event and gives back
								coords and window id.

	INPUTS:
		*x			pointer to x coordinate int
		*y			pointer to y coordinate int

	RETURNS:  Id of window (if any) touched at release

********************************************************************/
int getrelease(int *x, int *y)
{
	int bb,bw = BUTTONBORDERWIDTH,pressed=0;
	WINDOW *w,*ow,*hkw;
																					// If x and y are negative, that
																					// is a signal that get press
																					// detected a hotkey press, so we
																					// will just bail out with what it
																					// found
	if(*x == -1 && *y == -1) return(return_hold);

	VW_mousestatus(x,y,&bb);          			// initialize
	while (!bb) {                       		// wait for mouse/keyboard press
		VW_mousestatus(x,y,&bb);
		if(kbhit()) {                         // keypress? check for hotkey
			hkw = gethotkeywin();
			if(hkw) {                           // valid window?
				*x = hkw->x + hkw->w/2;           // set coordinates to center
				*y = hkw->y + hkw->h/2;
				return(hkw->ret);                 // send id back
			}
		}
	}

	ow = inwhatwindow(*x,*y);               // get original window
																					// press the button if it is one
	if(ow && ow->type == WINTYPE_BUTTON) buttonaction(ow,1,bw);
	pressed = 1;

	while (bb)                              // wait for mouse release
		{
			w = inwhatwindow(*x,*y);
			if(w != ow) {        								// window change?
				if(pressed) {
					pressed = 0;                      // unpress old win
					if(ow && ow->type == WINTYPE_BUTTON) buttonaction(ow,0,bw);
				}
			}
			else if(!pressed) {                 // in original window and not pressed?
				if(ow && ow->type == WINTYPE_BUTTON) buttonaction(ow,1,bw);
				pressed = 1;                      // mark pressed
			}
			VW_mousestatus(x,y,&bb);

		}

	if(w != ow) return(0);                  // not in a window.  return 0

	if(ow) {                                // if there is an original window
		if(ow->type == WINTYPE_BUTTON) buttonaction(ow,0,bw);  // release button
		return ow->ret;                       // return id
	}
	else return(0);                         // must have been no window...
}

/*************************************************************************
	buttonaction(win,action);

	DESCRIPTION: handles Press/release graphics

		win			button to change
		action	0 = up, 1 = down
		bw			border width

**************************************************************************/
void buttonaction(WINDOW *win, int action, int bw)
{
	int i,c,x1,x2,y1,y2;

	x1 = win->x;
	y1 = win->y;
	x2 = win->x + win->w;
	y2 = win->y + win->h;

	VW_hidemouse();                 // get mouse out of the way

	if(!action) {                   // release: button up
		for(i=1; i< bw+1; i++) {            // loop through border thickness
			VW_line(SHADOWCOLOR,x1+i,y2-i,x2-i,y2-i);  // right side
			VW_line(SHADOWCOLOR,x2-i,y2-i,x2-i,y1+i);  // bottom

			VW_line(HIGHLIGHTCOLOR,x1+i,y2-i,x1+i,y1+i);  // left side
			VW_line(HIGHLIGHTCOLOR,x1+i,y1+i,x2-i,y1+i);  // top
		}
	}

	else {                           // button down

		for(i=1; i< bw+1; i++) {           // loop through border thickness
			VW_line(HIGHLIGHTCOLOR,x1+i,y2-i,x2-i,y2-i);  // right side
			VW_line(HIGHLIGHTCOLOR,x2-i,y2-i,x2-i,y1+i);  // bottom

			VW_line(SHADOWCOLOR,x1+i,y2-i,x1+i,y1+i);  // left side
			VW_line(SHADOWCOLOR,x1+i,y1+i,x2-i,y1+i);  // top
		}
	}
	VW_showmouse();                 // ring mouse cursor back
}
/********************************************************************
	void drawbox(x1,y1,x2,y2,bw,hc,sc,bc)

	DESCRIPTION:  This draws a generic pyramid-type grey rectangle
								This is similar to DrawBox(), except
								that it does not take a window as an argument

********************************************************************/
void drawbox(int x1,int y1,int x2,int y2,int bw,int hc, int sc, int bc)
{
	int i,c;

	VW_hidemouse();                 // get mouse out of the way
	VW_bar(bc,x1,y1,x2,y2); // blank the window

	for(i=0; i< bw; i++)            // loop through border thickness
		{
			VW_line(sc,x1+i,y2-i,x2-i,y2-i);  // right side
			VW_line(sc,x2-i,y2-i,x2-i,y1+i);  // bottom

			VW_line(hc,x1+i,y2-i,x1+i,y1+i);  // left side
			VW_line(hc,x1+i,y1+i,x2-i,y1+i);  // top
		}
	VW_showmouse();                 // ring mouse cursor back
}

/********************************************************************
	void drawpit(x1,y1,x2,y2,bw,hc,sc,bc)

	DESCRIPTION:  This draws a generic pyramid-type(sunken) grey rectangle
								This is similar to DrawPit(), except
								that it does not take a window as an argument

********************************************************************/
void drawpit(int x1,int y1,int x2,int y2,int bw,int hc, int sc, int bc)
{
	int i,c;

	VW_hidemouse();                 // get mouse out of the way
	VW_bar(bc,x1,y1,x2,y2); // blank the window

	for(i=0; i< bw; i++)            // loop through border thickness
		{
			VW_line(hc,x1+i,y2-i,x2-i,y2-i);  // right side
			VW_line(hc,x2-i,y2-i,x2-i,y1+i);  // bottom

			VW_line(sc,x1+i,y2-i,x1+i,y1+i);  // left side
			VW_line(sc,x1+i,y1+i,x2-i,y1+i);  // top
		}
	VW_showmouse();                 // ring mouse cursor back
}

/*************************************************************************
	inkey();

	DESCRIPTION: Works like the BASIC function inkey$. It returns the top
							 character in the keyboard buffer, and NULL if the buffer
							 is empty.

**************************************************************************/
char inkey(void)
{
	if(kbhit()) {
		return(getch());
	}
	else return 0;
}
